/*
 * Rationale.java
 *
 * Created on 1. mai 2007, 12:23
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;

/**
 *
 * @author Gyrd Norvoll 
 */
public class Argument extends Artifact implements Serializable {
    public static final String recognizer = "Argument";
    public static final String traceabilityStage = "pre_rs";
    private String classType = recognizer;
   
    private String description;
    
    private ArrayList connectedArtifactCategories = new ArrayList();
    
    private Assumption dependingAssumption;
    private Alternative validatedAlternative;
    private Stakeholder proposingStakeholder;
    
    
    
    /** Creates a new instance of Rationale */
    public Argument() {
        super(recognizer, traceabilityStage, new Date());
        buildModel();
    }
    public Argument(Long id, String tag, String description){
        super(id, tag, traceabilityStage, recognizer, new Date());
        this.description = description;
        
        buildModel();
    }
    private void buildModel(){
        HashMap t = new HashMap();
        t.put("recognizer", no.traceme.model.Assumption.recognizer);
        t.put("object", dependingAssumption);
        t.put("trace", "depends on");
        getConnectedArtifactCategories().add(t);
        
        t = new HashMap();
        t.put("recognizer", no.traceme.model.Alternative.recognizer);
        t.put("object", validatedAlternative);
        t.put("trace", "is validated by");
        getConnectedArtifactCategories().add(t);
        
        t = new HashMap();
        t.put("recognizer", no.traceme.model.Stakeholder.recognizer);
        t.put("object", proposingStakeholder);
        t.put("trace", "proposes");
        getConnectedArtifactCategories().add(t);
    }
    
   public String toString(){
       return "Argument";
   }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public ArrayList getConnectedArtifactCategories() {
        return connectedArtifactCategories;
    }

    public void setConnectedArtifactCategories(ArrayList connectedArtifactCategories) {
        this.connectedArtifactCategories = connectedArtifactCategories;
    }

    public String getClassType() {
        return classType;
    }

    public void setClassType(String classType) {
        this.classType = classType;
    }

    public Assumption getDependingAssumption() {
        return dependingAssumption;
    }

    public void setDependingAssumption(Assumption dependingAssumption) {
        this.dependingAssumption = dependingAssumption;
        Iterator i = connectedArtifactCategories.iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("Assumption")){
                m.put("object", dependingAssumption);
            }
            
        }
    }

    public Alternative getValidatedAlternative() {
        return validatedAlternative;
    }

    public void setValidatedAlternative(Alternative validatedAlternative) {
        this.validatedAlternative = validatedAlternative;
        Iterator i = connectedArtifactCategories.iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("Alternative")){
                m.put("object", validatedAlternative);
            }
            
        }
    }

    public Stakeholder getProposingStakeholder() {
        return proposingStakeholder;
    }

    public void setProposingStakeholder(Stakeholder proposingStakeholder) {
        this.proposingStakeholder = proposingStakeholder;
        Iterator i = connectedArtifactCategories.iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("Stakeholder")){
                m.put("object", proposingStakeholder);
            }
            
        }
    }
}
