/*
 * Artifact.java
 *
 * Created on 7. mai 2007, 15:27
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.util.ArrayList;
import java.util.Date;

/**
 *
 * @author Gyrd Norvoll 
 */
public abstract class Artifact {
     private Long id;
    private String tag;
    private String traceabilityStage;
    private String childType;
    private Date creationDate;
    private Date lastChange;
    private long versionNumber;
    private Date deprecatedDate;
    private ArrayList versions = new ArrayList();
    /** Creates a new instance of Artifact */
    public Artifact() {
    }
    public Artifact(String childType, String traceStage, Date creationDate){
        this.setChildType(childType);
        this.traceabilityStage = traceStage;
        this.setCreationDate(creationDate);
        this.versionNumber = 1;
    }
    public Artifact(Long id, String tag, String traceStage, String childType, Date creationDate) {
        this.id=id;
        this.tag=tag;
        this.setTraceabilityStage(traceStage);
        this.setChildType(childType);
        this.setCreationDate(creationDate);
        this.versionNumber = 1;
    }
    
 
    
    public Long getId() {
        return id;
    }


    public String getTag() {
        return tag;
    }


    public void setId(Long id) {
        this.id = id;
    }


    public void setTag(String tag) {
        this.tag = tag;
    }

    public String getTraceabilityStage() {
        return traceabilityStage;
    }

    public void setTraceabilityStage(String traceabilityStage) {
        this.traceabilityStage = traceabilityStage;
    }

    public String getChildType() {
        return childType;
    }

    public void setChildType(String childType) {
        this.childType = childType;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public Date getLastChange() {
        return lastChange;
    }

    public void setLastChange(Date lastChange) {
        this.lastChange = lastChange;
    }

    public long getVersionNumber() {
        return versionNumber;
    }

    public void setVersionNumber(long versionNumber) {
        this.versionNumber = versionNumber;
    }

    public ArrayList getVersions() {
        return versions;
    }

    public void setVersions(ArrayList versions) {
        this.versions = versions;
    }

    public Date getDeprecatedDate() {
        return deprecatedDate;
    }

    public void setDeprecatedDate(Date deprecatedDate) {
        this.deprecatedDate = deprecatedDate;
    }
    public void deprecateThis(Artifact newArtifact){
        setDeprecatedDate(newArtifact.getCreationDate());
        newArtifact.getVersions().add(this);
        newArtifact.setVersionNumber(this.getVersionNumber() + 1);
    }
}
