/*
 * Design.java
 *
 * Created on 12. mai 2007, 17:15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 *
 * @author Gyrd Norvoll 
 */
public class Design extends Artifact implements Serializable {
        
    public static final String recognizer = "Design";
    public static final String traceabilityStage = "post_frs";
    private String classType = recognizer;
    
    private String title;
    private String type;
    private String description;
    private String location;
    
    private Set drivingFormalRequirements = new HashSet();
    private Set definedSystemComponents = new HashSet();
    
    private ArrayList connectedArtifactCategories = new ArrayList();
    
    /** Creates a new instance of SystemComponent */
    public Design() {
        super(recognizer, traceabilityStage, new Date());
        buildModel();
    }
    public Design(Long id, String tag, String title, String description){
        super(id, tag, traceabilityStage, recognizer, new Date());
        //this.setTitle(title);
        //this.setDescription(description);
        buildModel();
    }
    private void buildModel(){
        HashMap m = new HashMap();
        m.put("recognizer", no.traceme.model.FormalRequirement.recognizer);
        m.put("set", drivingFormalRequirements);
        m.put("trace", "drives");
        getConnectedArtifactCategories().add(m);
        m = new HashMap();
        m.put("recognizer", no.traceme.model.SystemComponent.recognizer);
        m.put("set", definedSystemComponents);
        m.put("trace", "is defined by");
        getConnectedArtifactCategories().add(m);
        
    }

    public String getClassType() {
        return classType;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public ArrayList getConnectedArtifactCategories() {
        return connectedArtifactCategories;
    }

    public void setConnectedArtifactCategories(ArrayList connectedArtifactCategories) {
        this.connectedArtifactCategories = connectedArtifactCategories;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    

    public Set getDefinedSystemComponents() {
        return definedSystemComponents;
    }

    public void setDefinedSystemComponents(Set definedSystemComponents) {
        this.definedSystemComponents = definedSystemComponents;
    }
     public void addDefinedSystemComponent(SystemComponent systemComponent){
        if(systemComponent == null) throw new IllegalArgumentException("Null systemComponent");
        systemComponent.setDefiningDesign(this);
        definedSystemComponents.add(systemComponent);
        
    }
    public void removeDefinedSystemComponent(SystemComponent systemComponent){
        if(systemComponent == null) throw new IllegalArgumentException("Null systemComponent");
        if(definedSystemComponents.contains(systemComponent)){
            systemComponent.setDefiningDesign(null);
            definedSystemComponents.remove(systemComponent);
            
        }
    }
    public String toString(){
        return "Design";
    }

    public Set getDrivingFormalRequirements() {
        return drivingFormalRequirements;
    }

    public void setDrivingFormalRequirements(Set drivingFormalRequirements) {
        this.drivingFormalRequirements = drivingFormalRequirements;
    }
    public void addDrivingFormalRequirement(FormalRequirement formalReq){
        if(formalReq == null) throw new IllegalArgumentException("Null formalReq");
        drivingFormalRequirements.add(formalReq);
        
    }
    public void removeDrivingFormalRequirement(FormalRequirement formalReq){
        if(formalReq == null) throw new IllegalArgumentException("Null formalReq");
        if(drivingFormalRequirements.contains(formalReq)){
            drivingFormalRequirements.remove(formalReq);
            
        }
    }
}
