/*
 * Design.java
 *
 * Created on 12. mai 2007, 17:15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Set;

/**
 *
 * @author Gyrd Norvoll 
 */
public class ExternalSystem extends Artifact implements Serializable {
        
    public static final String recognizer = "ExternalSystem";
    public static final String traceabilityStage = "post_frs";
    private String classType = recognizer;
    
    private String name;
    private String type;
    private String description;
    private String owner;
    
    private Set dependingSystemComponents;
    
    
    private ArrayList connectedArtifactCategories = new ArrayList();
    
    /** Creates a new instance of ExternalSystem */
    public ExternalSystem() {
        super(recognizer, traceabilityStage, new Date());
        buildModel();
    }
    public ExternalSystem(Long id, String tag, String title, String description){
        super(id, tag, traceabilityStage, recognizer, new Date());
        //this.setTitle(title);
        //this.setDescription(description);
        buildModel();
    }
    private void buildModel(){
        HashMap m = new HashMap();
        m.put("recognizer", no.traceme.model.FormalRequirement.recognizer);
        m.put("set", dependingSystemComponents);
        m.put("trace", "depends on");
        getConnectedArtifactCategories().add(m);
        
    }

    public String getClassType() {
        return classType;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public ArrayList getConnectedArtifactCategories() {
        return connectedArtifactCategories;
    }

    public void setConnectedArtifactCategories(ArrayList connectedArtifactCategories) {
        this.connectedArtifactCategories = connectedArtifactCategories;
    }


    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public Set getDependingSystemComponents() {
        return dependingSystemComponents;
    }

    public void setDependingSystemComponents(Set dependingSystemComponents) {
        this.dependingSystemComponents = dependingSystemComponents;
    }
    public void addDependingSystemComponent(SystemComponent systemComponent){
        if(systemComponent == null) throw new IllegalArgumentException("Null systemComponent");
        systemComponent.setRequiredExternalSystem(this);
        dependingSystemComponents.add(systemComponent);
        
    }
    public void removeDependingSystemComponent(SystemComponent systemComponent){
        if(systemComponent == null) throw new IllegalArgumentException("Null systemComponent");
        if(dependingSystemComponents.contains(systemComponent)){
            systemComponent.setFulfilledFormalRequirement(null);
            dependingSystemComponents.remove(systemComponent);
            
        }
    }
    public String toString(){
        return "External System";
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }
}
