/*
 * Requirement.java
 *
 * Created on 1. mai 2007, 12:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

/**
 *
 * @author Gyrd Norvoll 
 */
public class Mandate extends Artifact implements Serializable{
    public static final String recognizer = "Mandate";
    public static final String traceabilityStage = "pre_frs";
    private String classType = recognizer;
 
    private String title;
    private String description;
    private String type;
    private String location;
    
    private Set formalRequirements;
    
    
    private ArrayList connectedArtifactCategories = new ArrayList();
    
    /**
     * Creates a new instance of Requirement
     */
    public Mandate() {
        super(recognizer, traceabilityStage, new Date());
        buildModel();
    }
    
    public Mandate(Long id, String tag, String title, String description){
        super(id, tag, traceabilityStage, recognizer, new Date());
        
        buildModel();
    }
    
    private void buildModel(){
        
        HashMap m = new HashMap();
        m.put("recognizer", no.traceme.model.FormalRequirement.recognizer);
        m.put("set", formalRequirements);
        m.put("trace", "supports");
        getConnectedArtifactCategories().add(m);
        
        
         
    }

    public String getClassType() {
        return classType;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public ArrayList getConnectedArtifactCategories() {
        return connectedArtifactCategories;
    }

    public void setConnectedArtifactCategories(ArrayList connectedArtifactCategories) {
        this.connectedArtifactCategories = connectedArtifactCategories;
    }

    public Set getFormalRequirements() {
        return formalRequirements;
    }

    public void setFormalRequirements(Set formalRequirements) {
        this.formalRequirements = formalRequirements;
    }
    public void addFormalRequirement(FormalRequirement formalRequirement){
        if(formalRequirement == null) throw new IllegalArgumentException("Null formalRequirement");
        formalRequirements.add(formalRequirement);
    }
    public void removeFormalRequirement(FormalRequirement formalRequirement){
        if(formalRequirement == null) throw new IllegalArgumentException();
        if(formalRequirements.contains(formalRequirement)){
            formalRequirements.remove(formalRequirement);
        }
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }
    public String toString(){
        return "Mandate";
    }
}
