/*
 * Package.java
 *
 * Created on 12. mai 2007, 18:07
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author Gyrd Norvoll 
 */
public class Package extends SystemComponent {
    public static final String recognizer = "Package";
    
    private Set containingClasses = new HashSet();
    
    /** Creates a new instance of Package */
    public Package() {
        super(recognizer);
        buildModel();
    }
    private void buildModel(){
         HashMap t = new HashMap();
        t.put("recognizer", no.traceme.model.ProgrammingClass.recognizer);
        t.put("set", containingClasses);
        t.put("trace", "is part of");
        getConnectedArtifactCategories().add(t);
        
    }

    public Set getContainingClasses() {
        return containingClasses;
    }

    public void setContainingClasses(Set containingClasses) {
        this.containingClasses = containingClasses;
    }
    public void addProgrammingClass(ProgrammingClass containedClass){
        if(containedClass == null) throw new IllegalArgumentException("Null containedClass");
        containedClass.setContainingPackage(this);
        containingClasses.add(containedClass);
    }
    public void removeProgrammingClass(ProgrammingClass containedClass){
        if(containedClass == null) throw new IllegalArgumentException();
        if(containingClasses.contains(containedClass)){
            containedClass.setContainingPackage(null);
            containingClasses.remove(containedClass);
        }
    }
    public String toString(){
        return "Package";
    }
}
