/*
 * PreRS.java
 *
 * Created on 9. mai 2007, 10:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 *
 * @author Gyrd Norvoll 
 */
public class PostFRS {
    
    private Project project;
    
    private ArrayList artifactTitles = new ArrayList();
    private HashMap properties = new HashMap();
    
    private Set artifactsByCategory = new HashSet(); //just an assistant arraylist, not in use
    
    private ArrayList postFRS = new ArrayList();
    
    private ArrayList traces = new ArrayList();
  
    private Set modules = new HashSet();
    private Set packages = new HashSet();
    private Set components = new HashSet();
    private Set classes = new HashSet();
    private Set designs = new HashSet();
    private Set prototypes = new HashSet();
    private Set inspections = new HashSet();
    private Set simulations = new HashSet();
    private Set tests = new HashSet();
    private Set externalSystems = new HashSet();
    
    private Set systemComponents = new HashSet();
    private Set verificationProcedures = new HashSet();
    
    /** Creates a new instance of PreRS */
    public PostFRS(Project p) {
        project = p;
        
    }
    
    public void initialise(){
        buildTraces();
        postFRS.add(modules);
        
        artifactTitles.add(no.traceme.model.Module.recognizer);
        ArrayList propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("implementingLanguage", "text", "Implementing language", "String"));
        properties.put(no.traceme.model.Module.recognizer, propertyKeeper);
        
        postFRS.add(packages);

        artifactTitles.add(no.traceme.model.Package.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        properties.put(no.traceme.model.Package.recognizer, propertyKeeper);
        
        postFRS.add(components);
        
        artifactTitles.add(no.traceme.model.Component.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("implementingLanguage", "text", "Implementing language", "String"));
        properties.put(no.traceme.model.Component.recognizer, propertyKeeper);
        
        postFRS.add(classes);
        
        artifactTitles.add(no.traceme.model.ProgrammingClass.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("implementingLanguage", "text", "Implementing language", "String"));
        propertyKeeper.add(new Property("authoringStakeholder", "text", "Authoring stakeholder", "Stakeholder"));
        properties.put(no.traceme.model.ProgrammingClass.recognizer, propertyKeeper);
        
        postFRS.add(externalSystems);
        
        artifactTitles.add(no.traceme.model.ExternalSystem.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("type", "text", "Type", "String"));
        propertyKeeper.add(new Property("name", "text", "Name", "String"));
        propertyKeeper.add(new Property("owner", "text", "Owner", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        properties.put(no.traceme.model.ExternalSystem.recognizer, propertyKeeper);
        
        postFRS.add(designs);
        
        artifactTitles.add(no.traceme.model.Design.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("type", "text", "Type", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("drivingFormalRequirement", "select", "Driving formal requirement", "FormalRequirement"));
        properties.put(no.traceme.model.Design.recognizer, propertyKeeper);
        
        postFRS.add(prototypes);
        
        artifactTitles.add(no.traceme.model.Prototype.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("name", "text", "Name", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("targetedFormalRequirement", "select", "Targeted formal requirement", "FormalRequirement"));
        properties.put(no.traceme.model.Prototype.recognizer, propertyKeeper);
        
        postFRS.add(inspections);
        
        artifactTitles.add(no.traceme.model.Inspection.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("name", "text", "Name", "String"));
        propertyKeeper.add(new Property("targetedFormalRequirement", "select", "Targeted formal requirement", "FormalRequirement"));
        propertyKeeper.add(new Property("inspectingStakeholder", "select", "Inspecting stakeholder", "Stakeholder"));
        properties.put(no.traceme.model.Inspection.recognizer, propertyKeeper);
        
        postFRS.add(simulations);
        
        artifactTitles.add(no.traceme.model.Simulation.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("name", "text", "Name", "String"));
        propertyKeeper.add(new Property("simulationEnvironment", "text", "Simulation environment", "String"));
        propertyKeeper.add(new Property("targetedFormalRequirement", "select", "Targeted formal requirement", "FormalRequirement"));
        properties.put(no.traceme.model.Simulation.recognizer, propertyKeeper);
        
        postFRS.add(tests);
        
        artifactTitles.add(no.traceme.model.Test.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("name", "text", "Name", "String"));
        propertyKeeper.add(new Property("testedSystemComponent", "select", "Tested system component", "SystemComponent"));
        
        properties.put(no.traceme.model.Test.recognizer, propertyKeeper);
        
    }
    private void buildTraces(){
        HashMap traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Design.recognizer);
        traceKeeper.put("trace", "defines");
        traceKeeper.put("endingArtifact", no.traceme.model.SystemComponent.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.FormalRequirement.recognizer);
        traceKeeper.put("trace", "drives");
        traceKeeper.put("endingArtifact", no.traceme.model.Design.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.FormalRequirement.recognizer);
        traceKeeper.put("trace", "is verified by");
        traceKeeper.put("endingArtifact", no.traceme.model.VerificationProcedure.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.ExternalSystem.recognizer);
        traceKeeper.put("trace", "is required by");
        traceKeeper.put("endingArtifact", no.traceme.model.SystemComponent.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Package.recognizer);
        traceKeeper.put("trace", "contains");
        traceKeeper.put("endingArtifact", no.traceme.model.ProgrammingClass.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Test.recognizer);
        traceKeeper.put("trace", "tests");
        traceKeeper.put("endingArtifact", no.traceme.model.SystemComponent.recognizer);
        traces.add(traceKeeper);
    }
    
    public ArrayList getAllArtifacts(){
        return postFRS;
    }
    public void setAllArtifacts(ArrayList l){
        postFRS = l;
    }
    public Set getArtifactsByCategory(String category){
        if(category.equalsIgnoreCase(no.traceme.model.Module.recognizer)) return modules;
        else if(category.equalsIgnoreCase(no.traceme.model.Package.recognizer)) return packages;
        else if(category.equalsIgnoreCase(no.traceme.model.Component.recognizer)) return components;
        else if(category.equalsIgnoreCase(no.traceme.model.ProgrammingClass.recognizer)) return classes;
        else if(category.equalsIgnoreCase(no.traceme.model.ExternalSystem.recognizer)) return externalSystems;
        else if(category.equalsIgnoreCase(no.traceme.model.Design.recognizer)) return designs;
        else if(category.equalsIgnoreCase(no.traceme.model.Prototype.recognizer)) return prototypes;
        else if(category.equalsIgnoreCase(no.traceme.model.Inspection.recognizer)) return inspections;
        else if(category.equalsIgnoreCase(no.traceme.model.Simulation.recognizer)) return simulations;
        else if(category.equalsIgnoreCase(no.traceme.model.Test.recognizer)) return tests;
        else if(category.equalsIgnoreCase(no.traceme.model.VerificationProcedure.recognizer)) return verificationProcedures;
        else return systemComponents; // this should not happen
    }
   
    public ArrayList getArtifactTitles() {
        return artifactTitles;
    }

    public HashMap getProperties() {
        return properties;
    }

    public void setProperties(HashMap properties) {
        this.properties = properties;
    }


    public ArrayList getTraces() {
        return traces;
    }

    public void setTraces(ArrayList traces) {
        this.traces = traces;
    }

    public Set getModules() {
        return modules;
    }

    public void setModules(Set modules) {
        this.modules = modules;
    }
    public Module getModuleById(Long id){
        Iterator i = modules.iterator();
        Module chosenModule = null;
        while(i.hasNext()){
            Module s = (Module) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenModule = s;
            }
        }
        return chosenModule;
    }
    public Set getPackages() {
        return packages;
    }

    public void setPackages(Set packages) {
        this.packages = packages;
    }
    public Package getPackageById(Long id){
        Iterator i = packages.iterator();
        Package chosenPackage = null;
        while(i.hasNext()){
            Package s = (Package) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenPackage = s;
            }
        }
        return chosenPackage;
    }
    public Set getComponents() {
        return components;
    }

    public void setComponents(Set components) {
        this.components = components;
    }
    public Component getComponentById(Long id){
        Iterator i = components.iterator();
        Component chosenComponent = null;
        while(i.hasNext()){
            Component s = (Component) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenComponent = s;
            }
        }
        return chosenComponent;
    }
    public Set getClasses() {
        return classes;
    }

    public void setClasses(Set classes) {
        this.classes = classes;
    }
    public ProgrammingClass getProgrammingClassById(Long id){
        Iterator i = classes.iterator();
        ProgrammingClass chosenProgrammingClass = null;
        while(i.hasNext()){
            ProgrammingClass s = (ProgrammingClass) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenProgrammingClass = s;
            }
        }
        return chosenProgrammingClass;
    }
    public Set getDesigns() {
        return designs;
    }

    public void setDesigns(Set designs) {
        this.designs = designs;
    }
    public Design getDesignById(Long id){
        Iterator i = designs.iterator();
        Design chosenDesign = null;
        while(i.hasNext()){
            Design s = (Design) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenDesign = s;
            }
        }
        return chosenDesign;
    }
    
    public void addDesign(Design design){
        if(design == null) throw new IllegalArgumentException();
        if(!(designs.contains(design))){
            designs.add(design);
        }
    }
    public void removeDesign(Design design){
        if(design == null) throw new IllegalArgumentException();
        if(designs.contains(design)){
            designs.remove(design);
        }
    }
    
    public Set getPrototypes() {
        return prototypes;
    }

    public void setPrototypes(Set prototypes) {
        this.prototypes = prototypes;
    }
    public Prototype getPrototypeById(Long id){
        Iterator i = prototypes.iterator();
        Prototype chosenPrototype = null;
        while(i.hasNext()){
            Prototype s = (Prototype) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenPrototype = s;
            }
        }
        return chosenPrototype;
    }
    public Set getInspections() {
        return inspections;
    }

    public void setInspections(Set inspections) {
        this.inspections = inspections;
    }
    public Inspection getInspectionById(Long id){
        Iterator i = inspections.iterator();
        Inspection chosenInspection = null;
        while(i.hasNext()){
            Inspection s = (Inspection) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenInspection = s;
            }
        }
        return chosenInspection;
    }
    public Set getSimulations() {
        return simulations;
    }

    public void setSimulations(Set simulations) {
        this.simulations = simulations;
    }
    public Simulation getSimulationById(Long id){
        Iterator i = simulations.iterator();
        Simulation chosenSimulation = null;
        while(i.hasNext()){
            Simulation s = (Simulation) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenSimulation = s;
            }
        }
        return chosenSimulation;
    }
    public Set getExternalSystems() {
        return externalSystems;
    }

    public void setExternalSystems(Set externalSystems) {
        this.externalSystems = externalSystems;
    }
    public ExternalSystem getExternalSystemById(Long id){
        Iterator i = externalSystems.iterator();
        ExternalSystem chosenExternalSystem = null;
        while(i.hasNext()){
            ExternalSystem s = (ExternalSystem) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenExternalSystem = s;
            }
        }
        return chosenExternalSystem;
    }
    
    public void addExternalSystem(ExternalSystem externalSystem){
        if(externalSystem == null) throw new IllegalArgumentException();
        if(!(externalSystems.contains(externalSystem))){
            externalSystems.add(externalSystem);
        }
    }
    public void removeExternalSystem(ExternalSystem externalSystem){
        if(externalSystem == null) throw new IllegalArgumentException();
        if(externalSystems.contains(externalSystem)){
            externalSystems.remove(externalSystem);
        }
    }
    
    public void addSystemComponent(SystemComponent comp){
    if(comp != null){
        String classType = comp.getChildType();
        
        systemComponents.add(comp);
        project.addRecentArtifact(comp);
        
        if(classType.equalsIgnoreCase(ProgrammingClass.recognizer)){
            ProgrammingClass pc = (ProgrammingClass) comp;
            if(pc != null){
            classes.add(pc);
            }
        }else if(classType.equalsIgnoreCase(Module.recognizer)){
            Module mod = (Module) comp;
            if(mod != null){
            modules.add(mod);
            }
        }else if(classType.equalsIgnoreCase(Package.recognizer)){
            Package pack = (Package) comp;
            if(pack != null){
            packages.add(pack);
            }
        }else if(classType.equalsIgnoreCase(Component.recognizer)){
            Component component = (Component) comp;
            if(component != null){
            components.add(component);
            }
        }else{
            //do nothing
        }
        }
    }
    public SystemComponent getSystemComponentById(Long id){
        Iterator i = systemComponents.iterator();
        SystemComponent chosenSystemComponent = null;
        while(i.hasNext()){
            SystemComponent s = (SystemComponent) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenSystemComponent = s;
            }
        }
        return chosenSystemComponent;
    }
    public void addVerificationProcedure(VerificationProcedure proc){
        if(proc != null){
        String classType = proc.getChildType();
        
        verificationProcedures.add(proc);
        project.addRecentArtifact(proc);
        
        if(classType.equalsIgnoreCase(Prototype.recognizer)){
            Prototype prot = (Prototype) proc;
            if(prot != null){
            prototypes.add(prot);
            }
        }else if(classType.equalsIgnoreCase(Inspection.recognizer)){
            Inspection ins = (Inspection) proc;
            if(ins != null){
            inspections.add(ins);
            }
        }else if(classType.equalsIgnoreCase(Simulation.recognizer)){
            Simulation sim = (Simulation) proc;
            if(sim != null){
            simulations.add(sim);
            }
        }else if(classType.equalsIgnoreCase(Test.recognizer)){
            Test test = (Test) proc;
            if(test != null){
            tests.add(test);
            }
        }else{
            //do nothing
        }
        }
    }
    public VerificationProcedure getVerificationProcedureById(Long id){
        Iterator i = verificationProcedures.iterator();
        VerificationProcedure chosenVerificationProcedure = null;
        while(i.hasNext()){
            VerificationProcedure s = (VerificationProcedure) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenVerificationProcedure = s;
            }
        }
        return chosenVerificationProcedure;
    }

    public Set getSystemComponents() {
        return systemComponents;
    }

    public void setSystemComponents(Set systemComponents) {
        this.systemComponents = systemComponents;
    }

    public Set getVerificationProcedures() {
        return verificationProcedures;
    }

    public void setVerificationProcedures(Set verificationProcedures) {
        this.verificationProcedures = verificationProcedures;
    }

    public Set getTests() {
        return tests;
    }

    public void setTests(Set tests) {
        this.tests = tests;
    }
     public Test getTestById(Long id){
        Iterator i = tests.iterator();
        Test chosenTest = null;
        while(i.hasNext()){
            Test s = (Test) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenTest = s;
            }
        }
        return chosenTest;
    }
    
    public void addTest(Test test){
        if(test == null) throw new IllegalArgumentException();
        if(!(tests.contains(test))){
            tests.add(test);
        }
    }
    public void removeTest(Test test){
        if(test == null) throw new IllegalArgumentException();
        if(tests.contains(test)){
            tests.remove(test);
        }
    }
}
