/**
 * PreRS.java
 *
 * Created on 9. mai 2007, 10:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 *
 * @author Gyrd Norvoll 
 */
public class PreFRS {
    
    private Project project;
    
    private ArrayList artifactTitles = new ArrayList();
    
    private HashMap properties = new HashMap();
    
    private Set artifactsByCategory = new HashSet(); //just an assistant arraylist, not in use
    
    private ArrayList preFRS = new ArrayList();
    
    private ArrayList traces = new ArrayList();
    
    private Set formalRequirements = new HashSet();
    private Set mandates = new HashSet();
    private Set externalInterfaceRequirements = new HashSet();
    private Set functionalRequirements = new HashSet();
    private Set performanceRequirements = new HashSet();
    private Set softwareSystemAttributes = new HashSet();
    private Set designConstraints = new HashSet();
    
    
    /** Creates a new instance of PreRS */
    public PreFRS(Project p) {
        project = p;
        
    }
    
    public void initialise(){
        buildTraces();
        preFRS.add(mandates);
        
        artifactTitles.add(no.traceme.model.Mandate.recognizer);
        ArrayList propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("type", "text", "Type", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        properties.put(no.traceme.model.Mandate.recognizer, propertyKeeper);
        
        preFRS.add(externalInterfaceRequirements);

        artifactTitles.add(no.traceme.model.ExternalInterfaceRequirement.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("gist", "text", "Gist", "String"));
        propertyKeeper.add(new Property("priority", "text", "Priority", "String"));
        propertyKeeper.add(new Property("risk", "text", "Risk", "String"));
        propertyKeeper.add(new Property("status", "text", "Status", "String"));
        propertyKeeper.add(new Property("proserequirement", "select", "Defining prose requirement", "Requirement"));
        properties.put(no.traceme.model.ExternalInterfaceRequirement.recognizer, propertyKeeper);
        
        preFRS.add(functionalRequirements);
        
        artifactTitles.add(no.traceme.model.FunctionalRequirement.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("gist", "text", "Gist", "String"));
        propertyKeeper.add(new Property("priority", "text", "Priority", "String"));
        propertyKeeper.add(new Property("risk", "text", "Risk", "String"));
        propertyKeeper.add(new Property("status", "text", "Status", "String"));
        propertyKeeper.add(new Property("proserequirement", "select", "Defining prose requirement", "Requirement"));
        properties.put(no.traceme.model.FunctionalRequirement.recognizer, propertyKeeper);
        
        preFRS.add(performanceRequirements);
        
        artifactTitles.add(no.traceme.model.PerformanceRequirement.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("gist", "text", "Gist", "String"));
        propertyKeeper.add(new Property("priority", "text", "Priority", "String"));
        propertyKeeper.add(new Property("risk", "text", "Risk", "String"));
        propertyKeeper.add(new Property("status", "text", "Status", "String"));
        propertyKeeper.add(new Property("ambition", "text", "Ambition", "String"));
        propertyKeeper.add(new Property("scale", "text", "Scale", "String"));
        propertyKeeper.add(new Property("meter", "text", "Meter", "String"));
        propertyKeeper.add(new Property("proserequirement", "select", "Defining prose requirement", "Requirement"));
        
        properties.put(no.traceme.model.PerformanceRequirement.recognizer, propertyKeeper);
        
        preFRS.add(softwareSystemAttributes);
        
        artifactTitles.add(no.traceme.model.SoftwareSystemAttribute.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("gist", "text", "Gist", "String"));
        propertyKeeper.add(new Property("priority", "text", "Priority", "String"));
        propertyKeeper.add(new Property("risk", "text", "Risk", "String"));
        propertyKeeper.add(new Property("status", "text", "Status", "String"));
        propertyKeeper.add(new Property("ambition", "text", "Ambition", "String"));
        propertyKeeper.add(new Property("scale", "text", "Scale", "String"));
        propertyKeeper.add(new Property("meter", "text", "Meter", "String"));
        propertyKeeper.add(new Property("past", "text", "Past", "String"));
        propertyKeeper.add(new Property("record", "text", "Record", "String"));
        propertyKeeper.add(new Property("trend", "text", "Trend", "String"));
        propertyKeeper.add(new Property("goal", "text", "Goal", "String"));
        propertyKeeper.add(new Property("stretch", "text", "Stretch", "String"));
        propertyKeeper.add(new Property("wish", "text", "Wish", "String"));
        propertyKeeper.add(new Property("survival", "text", "Survival", "String"));
        propertyKeeper.add(new Property("fail", "text", "Fail", "String"));
        propertyKeeper.add(new Property("proserequirement", "select", "Defining prose requirement", "Requirement"));
        properties.put(no.traceme.model.SoftwareSystemAttribute.recognizer, propertyKeeper);
        
        preFRS.add(designConstraints);
        
        artifactTitles.add(no.traceme.model.DesignConstraint.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("gist", "text", "Gist", "String"));
        propertyKeeper.add(new Property("priority", "text", "Priority", "String"));
        propertyKeeper.add(new Property("risk", "text", "Risk", "String"));
        propertyKeeper.add(new Property("status", "text", "Status", "String"));
        propertyKeeper.add(new Property("proserequirement", "select", "Defining prose requirement", "Requirement"));
        properties.put(no.traceme.model.DesignConstraint.recognizer, propertyKeeper);
        
       
    }
    private void buildTraces(){
        HashMap traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.FormalRequirement.recognizer);
        traceKeeper.put("trace", "supports");
        traceKeeper.put("endingArtifact", no.traceme.model.Mandate.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Requirement.recognizer);
        traceKeeper.put("trace", "defines");
        traceKeeper.put("endingArtifact", no.traceme.model.FormalRequirement.recognizer);
        traces.add(traceKeeper);
    }
    
    public ArrayList getAllArtifacts(){
        return preFRS;
    }
    public void setAllArtifacts(ArrayList l){
        preFRS = l;
    }
    public Set getArtifactsByCategory(String category){
        if(category.equalsIgnoreCase(no.traceme.model.ExternalInterfaceRequirement.recognizer)) return externalInterfaceRequirements;
        else if(category.equalsIgnoreCase(no.traceme.model.PerformanceRequirement.recognizer)) return performanceRequirements;
        else if(category.equalsIgnoreCase(no.traceme.model.FunctionalRequirement.recognizer)) return functionalRequirements;
        else if(category.equalsIgnoreCase(no.traceme.model.DesignConstraint.recognizer)) return designConstraints;
        else if(category.equalsIgnoreCase(no.traceme.model.SoftwareSystemAttribute.recognizer)) return softwareSystemAttributes;
        else if(category.equalsIgnoreCase(no.traceme.model.Mandate.recognizer)) return mandates;
        else return formalRequirements; // this will happen
    }
    public Set getExternalInterfaceRequirements() {
        return externalInterfaceRequirements;
    }
    public ExternalInterfaceRequirement getExternalInterfaceRequirementById(Long id){
        Iterator i = externalInterfaceRequirements.iterator();
        ExternalInterfaceRequirement chosenExternalInterfaceRequirement = null;
        while(i.hasNext()){
            ExternalInterfaceRequirement s = (ExternalInterfaceRequirement) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenExternalInterfaceRequirement = s;
            }
        }
        return chosenExternalInterfaceRequirement;
    }
   public Set getPerformanceRequirements() {
        return performanceRequirements;
    }
    public PerformanceRequirement getPerformanceRequirementById(Long id){
        Iterator i = performanceRequirements.iterator();
        PerformanceRequirement chosenPerformanceRequirement = null;
        while(i.hasNext()){
            PerformanceRequirement s = (PerformanceRequirement) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenPerformanceRequirement = s;
            }
        }
        return chosenPerformanceRequirement;
    }
    
    public Set getFunctionalRequirements() {
        return functionalRequirements;
    }
    public FunctionalRequirement getFunctionalRequirementById(Long id){
        Iterator i = functionalRequirements.iterator();
        FunctionalRequirement chosenFunctionalRequirement = null;
        while(i.hasNext()){
            FunctionalRequirement s = (FunctionalRequirement) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenFunctionalRequirement = s;
            }
        }
        return chosenFunctionalRequirement;
    }
    public Set getSoftwareSystemAttributes() {
        return softwareSystemAttributes;
    }
    public SoftwareSystemAttribute getSoftwareSystemAttributeById(Long id){
        Iterator i = softwareSystemAttributes.iterator();
        SoftwareSystemAttribute chosenSoftwareSystemAttribute = null;
        while(i.hasNext()){
            SoftwareSystemAttribute s = (SoftwareSystemAttribute) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenSoftwareSystemAttribute = s;
            }
        }
        return chosenSoftwareSystemAttribute;
    }
    public Set getDesignConstraints() {
        return designConstraints;
    }
    public DesignConstraint getDesignConstraintById(Long id){
        Iterator i = designConstraints.iterator();
        DesignConstraint chosenDesignConstraint = null;
        while(i.hasNext()){
            DesignConstraint s = (DesignConstraint) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenDesignConstraint = s;
            }
        }
        return chosenDesignConstraint;
    }
    public Set getMandates() {
        return mandates;
    }
    public Mandate getMandateById(Long id){
        Iterator i = mandates.iterator();
        Mandate chosenMandate = null;
        while(i.hasNext()){
            Mandate s = (Mandate) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenMandate = s;
            }
        }
        return chosenMandate;
    }
    public ArrayList getArtifactTitles() {
        return artifactTitles;
    }

    public HashMap getProperties() {
        return properties;
    }

    public void setProperties(HashMap properties) {
        this.properties = properties;
    }

    public ArrayList getTraces() {
        return traces;
    }

    public void setTraces(ArrayList traces) {
        this.traces = traces;
    }

    public void setMandates(Set mandates) {
        this.mandates = mandates;
    }
    public void addMandate(Mandate mandate){
        if(mandate!= null){
            mandates.add(mandate);
            project.addRecentArtifact(mandate);
        }
    }
    public void setExternalInterfaceRequirements(Set externalInterfaceRequirements) {
        this.externalInterfaceRequirements = externalInterfaceRequirements;
    }

    public void setFunctionalRequirements(Set functionalRequirements) {
        this.functionalRequirements = functionalRequirements;
    }

    public void setPerformanceRequirements(Set performanceRequirements) {
        this.performanceRequirements = performanceRequirements;
    }

    public void setSoftwareSystemAttributes(Set softwareSystemAttributes) {
        this.softwareSystemAttributes = softwareSystemAttributes;
    }

    public void setDesignConstraints(Set designConstraints) {
        this.designConstraints = designConstraints;
    }
    public void addFormalRequirement(FormalRequirement fr){
    if(fr != null){
        String classType = fr.getChildType();
        System.out.println("formalRequirements before: " + formalRequirements.size());
        formalRequirements.add(fr);
        project.addRecentArtifact(fr);
        System.out.println("formalRequirements after: " + formalRequirements.size());
        if(classType.equalsIgnoreCase(DesignConstraint.recognizer)){
            DesignConstraint dc = (DesignConstraint) fr;
            if(dc != null){
            designConstraints.add(dc);
            }
        }else if(classType.equalsIgnoreCase(ExternalInterfaceRequirement.recognizer)){
            ExternalInterfaceRequirement eir = (ExternalInterfaceRequirement) fr;
            if(eir != null){
                System.out.println("externalInterfaceRequirement before: " + externalInterfaceRequirements.size());
            externalInterfaceRequirements.add(eir);
                System.out.println("externalInterfaceRequirement after: " + externalInterfaceRequirements.size());
            }
        }else if(classType.equalsIgnoreCase(FunctionalRequirement.recognizer)){
            FunctionalRequirement freq = (FunctionalRequirement) fr;
            if(freq != null){
            functionalRequirements.add(freq);
            }
        }else if(classType.equalsIgnoreCase(PerformanceRequirement.recognizer)){
            PerformanceRequirement pr = (PerformanceRequirement) fr;
            if(pr != null){
            performanceRequirements.add(pr);
            }
        }else if(classType.equalsIgnoreCase(SoftwareSystemAttribute.recognizer)){
            SoftwareSystemAttribute ssa = (SoftwareSystemAttribute) fr;
            if(ssa != null){
            softwareSystemAttributes.add(ssa);
            }
        }else{
            //do nothing
        }
        }
    }
    public FormalRequirement getFormalRequirementById(Long id){
        Iterator i = formalRequirements.iterator();
        FormalRequirement chosenFormalRequirement = null;
        while(i.hasNext()){
            FormalRequirement s = (FormalRequirement) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenFormalRequirement = s;
            }
        }
        return chosenFormalRequirement;
    }

    public Set getFormalRequirements() {
        return formalRequirements;
    }

    public void setFormalRequirements(Set formalRequirements) {
        this.formalRequirements = formalRequirements;
    }
}
