/*
 * PreRS.java
 *
 * Created on 9. mai 2007, 10:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 *
 * @author Gyrd Norvoll 
 */
public class PreRS {
    
    private Project project;
    
    private ArrayList artifactTitles = new ArrayList();
    private HashMap properties = new HashMap();
    
    private Set artifactsByCategory = new HashSet(); //just an assistant arraylist, not in use
    
    private ArrayList preRS = new ArrayList();
    
    private ArrayList traces = new ArrayList();
    
    private Set stakeholders = new HashSet();
    private Set rationales = new HashSet();
    private Set requirements = new HashSet();
    private Set requirementDescriptors = new HashSet();
    private Set changeProposals = new HashSet();
    private Set issues = new HashSet();
    private Set arguments = new HashSet();
    private Set alternatives = new HashSet();
    private Set assumptions = new HashSet();
    private Set debates = new HashSet();
    private Set decisions = new HashSet();
    
    /** Creates a new instance of PreRS */
    public PreRS(Project p) {
        project = p;
        
    }
    
    public void initialise(){
        buildTraces();
        preRS.add(requirements);
        
        artifactTitles.add(no.traceme.model.Requirement.recognizer);
        ArrayList propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("title", "text", "Title", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("owningStakeholder", "select", "Owning stakeholder", "Stakeholder"));
        properties.put(no.traceme.model.Requirement.recognizer, propertyKeeper);
        
        preRS.add(stakeholders);

        artifactTitles.add(no.traceme.model.Stakeholder.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("name", "text", "Name", "String"));
        propertyKeeper.add(new Property("position", "text", "Position", "String"));
        propertyKeeper.add(new Property("authority", "text", "Authority", "String"));
        propertyKeeper.add(new Property("category", "text", "Category", "String"));
        propertyKeeper.add(new Property("email", "text", "Email", "String"));
        propertyKeeper.add(new Property("phone", "text", "Phone", "String"));
        propertyKeeper.add(new Property("office", "text", "Office", "String"));
        propertyKeeper.add(new Property("company", "text", "Company", "String"));
        properties.put(no.traceme.model.Stakeholder.recognizer, propertyKeeper);
        
        preRS.add(changeProposals);
        
        artifactTitles.add(no.traceme.model.ChangeProposal.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("proposingStakeholder", "select", "Proposing stakeholder", "Stakeholder"));
        propertyKeeper.add(new Property("affectedRequirement", "select", "Affected requirement", "Requirement"));
        properties.put(no.traceme.model.ChangeProposal.recognizer, propertyKeeper);
        
        preRS.add(rationales);
        
        artifactTitles.add(no.traceme.model.Rationale.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        properties.put(no.traceme.model.Rationale.recognizer, propertyKeeper);
        
        preRS.add(requirementDescriptors);
        
        artifactTitles.add(no.traceme.model.RequirementDescriptor.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("type", "text", "Type", "String"));
        propertyKeeper.add(new Property("location", "text", "Location", "String"));
        propertyKeeper.add(new Property("authoringStakeholder", "select", "Authoring stakeholder", "Stakeholder"));
        propertyKeeper.add(new Property("describedRequirement", "select", "Described requirement", "Requirement"));
        properties.put(no.traceme.model.RequirementDescriptor.recognizer, propertyKeeper);
        
        preRS.add(issues);
        
        artifactTitles.add(no.traceme.model.Issue.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("generatingRequirement", "select", "Generating requirement", "Requirement"));
        properties.put(no.traceme.model.Issue.recognizer, propertyKeeper);
        
        preRS.add(assumptions);
        
        artifactTitles.add(no.traceme.model.Assumption.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        properties.put(no.traceme.model.Assumption.recognizer, propertyKeeper);
        
        preRS.add(arguments);
        
        artifactTitles.add(no.traceme.model.Argument.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("proposingStakeholder", "select", "Proposing stakeholder", "Stakeholder"));
        properties.put(no.traceme.model.Argument.recognizer, propertyKeeper);
        
        preRS.add(alternatives);
        
        artifactTitles.add(no.traceme.model.Alternative.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("proposingStakeholder", "select", "Proposing stakeholder", "Stakeholder"));
        properties.put(no.traceme.model.Alternative.recognizer, propertyKeeper);
        
        preRS.add(debates);
        
        artifactTitles.add(no.traceme.model.Debate.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("startingIssue", "select", "Issue starting debate", "Issue"));
        properties.put(no.traceme.model.Debate.recognizer, propertyKeeper);
        
        preRS.add(decisions);
        
        artifactTitles.add(no.traceme.model.Decision.recognizer);
        propertyKeeper = new ArrayList();
        propertyKeeper.add(new Property("id", "text", "ID", "Long"));
        propertyKeeper.add(new Property("tag", "text", "Tag", "String"));
        propertyKeeper.add(new Property("description", "textarea", "Description", "String"));
        propertyKeeper.add(new Property("context", "textarea", "Context", "String"));
        propertyKeeper.add(new Property("decisionMaker", "select", "Decision maker", "Stakeholder"));
        propertyKeeper.add(new Property("resolvedIssue", "select", "Resolved issue", "Issue"));
        properties.put(no.traceme.model.Decision.recognizer, propertyKeeper);
    }
    private void buildTraces(){
        HashMap traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Requirement.recognizer);
        traceKeeper.put("trace", "affects");
        traceKeeper.put("endingArtifact", no.traceme.model.Stakeholder.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Requirement.recognizer);
        traceKeeper.put("trace", "accepts");
        traceKeeper.put("endingArtifact", no.traceme.model.ChangeProposal.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Stakeholder.recognizer);
        traceKeeper.put("trace", "proposes");
        traceKeeper.put("endingArtifact", no.traceme.model.ChangeProposal.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Stakeholder.recognizer);
        traceKeeper.put("trace", "authors");
        traceKeeper.put("endingArtifact", no.traceme.model.RequirementDescriptor.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.ChangeProposal.recognizer);
        traceKeeper.put("trace", "is based on");
        traceKeeper.put("endingArtifact", no.traceme.model.Rationale.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Requirement.recognizer);
        traceKeeper.put("trace", "is based on");
        traceKeeper.put("endingArtifact", no.traceme.model.Rationale.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Issue.recognizer);
        traceKeeper.put("trace", "is generated by");
        traceKeeper.put("endingArtifact", no.traceme.model.Requirement.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Issue.recognizer);
        traceKeeper.put("trace", "starts");
        traceKeeper.put("endingArtifact", no.traceme.model.Debate.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Decision.recognizer);
        traceKeeper.put("trace", "is made by");
        traceKeeper.put("endingArtifact", no.traceme.model.Stakeholder.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Decision.recognizer);
        traceKeeper.put("trace", "resolves");
        traceKeeper.put("endingArtifact", no.traceme.model.Issue.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Debate.recognizer);
        traceKeeper.put("trace", "discusses");
        traceKeeper.put("endingArtifact", no.traceme.model.Alternative.recognizer);
        traces.add(traceKeeper);
        traceKeeper = new HashMap();
        traceKeeper.put("startingArtifact", no.traceme.model.Argument.recognizer);
        traceKeeper.put("trace", "validates");
        traceKeeper.put("endingArtifact", no.traceme.model.Alternative.recognizer);
        traces.add(traceKeeper);
    }
    
    public ArrayList getAllArtifacts(){
        return preRS;
    }
    public void setAllArtifacts(ArrayList l){
        preRS = l;
    }
    public Set getArtifactsByCategory(String category){
        if(category.equalsIgnoreCase(no.traceme.model.Requirement.recognizer)) return requirements;
        else if(category.equalsIgnoreCase(no.traceme.model.Stakeholder.recognizer)) return stakeholders;
        else if(category.equalsIgnoreCase(no.traceme.model.ChangeProposal.recognizer)) return changeProposals;
        else if(category.equalsIgnoreCase(no.traceme.model.Rationale.recognizer)) return rationales;
        else if(category.equalsIgnoreCase(no.traceme.model.RequirementDescriptor.recognizer)) return requirementDescriptors;
        else if(category.equalsIgnoreCase(no.traceme.model.Alternative.recognizer)) return alternatives;
        else if(category.equalsIgnoreCase(no.traceme.model.Argument.recognizer)) return arguments;
        else if(category.equalsIgnoreCase(no.traceme.model.Assumption.recognizer)) return assumptions;
        else if(category.equalsIgnoreCase(no.traceme.model.Debate.recognizer)) return debates;
        else if(category.equalsIgnoreCase(no.traceme.model.Decision.recognizer)) return decisions;
        else if(category.equalsIgnoreCase(no.traceme.model.Issue.recognizer)) return issues;
        else return requirements; // this should not happen
    }
    public Set getChangeProposals() {
        return changeProposals;
    }
    public ChangeProposal getChangeProposalById(Long id){
        Iterator i = changeProposals.iterator();
        ChangeProposal chosenChangeProposal = null;
        while(i.hasNext()){
            ChangeProposal s = (ChangeProposal) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenChangeProposal = s;
            }
        }
        return chosenChangeProposal;
    }
    private void setChangeProposals(Set changeProposals) {
        this.changeProposals = changeProposals;
    }
 
    public void addChangeProposal(ChangeProposal prop){
        if(prop == null) throw new IllegalArgumentException();
        //if(!(changeProposals.contains(prop))){
            changeProposals.add(prop);
            project.addRecentArtifact(prop);
        //}
    }
    public void removeChangeProposal(ChangeProposal prop){
        if(prop == null) throw new IllegalArgumentException();
        if(changeProposals.contains(prop)){
            changeProposals.remove(prop);
            project.removeRecentArtifact(prop);
        }
    }
   
    public Set getStakeholders() {
        return stakeholders;
    }

    private void setStakeholders(Set stakeholders) {
        this.stakeholders = stakeholders;
    }

        public void addStakeholder(Stakeholder s){
        if(s == null) throw new IllegalArgumentException();
        if(!(stakeholders.contains(s))){
            stakeholders.add(s);
            project.addRecentArtifact(s);
        }
    }
    public void removeStakeholder(Stakeholder s){
        if(s == null) throw new IllegalArgumentException();
        if(arguments.contains(s)){
            arguments.remove(s);
            project.removeRecentArtifact(s);
        }
    }
    public Stakeholder getStakeholderById(Long id){
        Iterator i = stakeholders.iterator();
        Stakeholder chosenStakeholder = null;
        while(i.hasNext()){
            Stakeholder s = (Stakeholder) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenStakeholder = s;
            }
        }
        return chosenStakeholder;
    }
    
    public Set getRationales() {
        return rationales;
    }
    public Rationale getRationaleById(Long id){
        Iterator i = rationales.iterator();
        Rationale chosenRationale = null;
        while(i.hasNext()){
            Rationale s = (Rationale) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenRationale = s;
            }
        }
        return chosenRationale;
    }
    private void setRationales(Set rationales) {
        this.rationales = rationales;
    }
    public void addRationale(Rationale r){
        if(r == null) throw new IllegalArgumentException();
        if(!(rationales.contains(r))){
            rationales.add(r);
            project.addRecentArtifact(r);
        }
    }
    public void removeRationale(Rationale r){
        if(r == null) throw new IllegalArgumentException();
        if(rationales.contains(r)){
            rationales.remove(r);
            project.removeRecentArtifact(r);
        }
    }
    public Set getRequirements() {
        return requirements;
    }
    public Requirement getRequirementById(Long id){
        Iterator i = requirements.iterator();
        Requirement chosenRequirement = null;
        while(i.hasNext()){
            Requirement r = (Requirement) i.next();
            if(r.getId().longValue() == id.longValue()){
                chosenRequirement = r;
            }
        }
        return chosenRequirement;
    }
    private void setRequirements(Set requirements) {
        this.requirements = requirements;
    }
    public void addRequirement(Requirement req){
        if(req == null) throw new IllegalArgumentException();
        if(!(requirements.contains(req))){
            requirements.add(req);
            project.addRecentArtifact(req);
        }
    }
    public void removeRequirement(Requirement req){
        if(req == null) throw new IllegalArgumentException();
        if(requirements.contains(req)){
            requirements.remove(req);
            project.removeRecentArtifact(req);
        }
    }
    public Set getRequirementDescriptors() {
        return requirementDescriptors;
    }
    public RequirementDescriptor getRequirementDescriptorById(Long id){
        Iterator i = requirementDescriptors.iterator();
        RequirementDescriptor chosenRequirementDescriptor = null;
        while(i.hasNext()){
            RequirementDescriptor s = (RequirementDescriptor) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenRequirementDescriptor = s;
            }
        }
        return chosenRequirementDescriptor;
    }
    private void setRequirementDescriptors(Set requirementDescriptors) {
        this.requirementDescriptors = requirementDescriptors;
    }
    public void addRequirementDescriptor(RequirementDescriptor recDesc){
        if(recDesc == null) throw new IllegalArgumentException();
        if(!(requirementDescriptors.contains(recDesc))){
            requirementDescriptors.add(recDesc);
            project.addRecentArtifact(recDesc);
        }
    }
    public void removeRequirementDescriptor(RequirementDescriptor recDesc){
        if(recDesc == null) throw new IllegalArgumentException();
        if(requirementDescriptors.contains(recDesc)){
            requirementDescriptors.remove(recDesc);
            project.removeRecentArtifact(recDesc);
        }
    }
      public Set getIssues() {
        return issues;
    }
    public Issue getIssueById(Long id){
        Iterator i = issues.iterator();
        Issue chosenIssue = null;
        while(i.hasNext()){
            Issue s = (Issue) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenIssue = s;
            }
        }
        return chosenIssue;
    }
    private void setIssues(Set issues) {
        this.issues = issues;
    }
   public void addIssue(Issue issue){
        if(issue == null) throw new IllegalArgumentException();
        if(!(issues.contains(issue))){
            issues.add(issue);
            project.addRecentArtifact(issue);
        }
    }
    public void removeIssue(Issue issue){
        if(issue == null) throw new IllegalArgumentException();
        if(issues.contains(issue)){
            issues.remove(issue);
            project.removeRecentArtifact(issue);
        }
    }
    public Set getArguments() {
        return arguments;
    }
    public Argument getArgumentById(Long id){
        Iterator i = arguments.iterator();
        Argument chosenArgument = null;
        while(i.hasNext()){
            Argument s = (Argument) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenArgument = s;
            }
        }
        return chosenArgument;
    }
    public void setArguments(Set arguments) {
        this.arguments = arguments;
    }
    
   public void addArgument(Argument argument){
        if(argument == null) throw new IllegalArgumentException();
        if(!(arguments.contains(argument))){
            arguments.add(argument);
            project.addRecentArtifact(argument);
        }
    }
    public void removeArgument(Argument argument){
        if(argument == null) throw new IllegalArgumentException();
        if(arguments.contains(argument)){
            arguments.remove(argument);
            project.removeRecentArtifact(argument);
        }
    }
    public Set getAlternatives() {
        return alternatives;
    }
    public Alternative getAlternativeById(Long id){
        Iterator i = alternatives.iterator();
        Alternative chosenAlternative = null;
        while(i.hasNext()){
            Alternative s = (Alternative) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenAlternative = s;
            }
        }
        return chosenAlternative;
    }
    public void setAlternatives(Set alternatives) {
        this.alternatives = alternatives;
    }
   public void addAlternative(Alternative alternative){
        if(alternative == null) throw new IllegalArgumentException();
        if(!(alternatives.contains(alternative))){
            alternatives.add(alternative);
            project.addRecentArtifact(alternative);
        }
    }
    public void removeAlternative(Alternative alternative){
        if(alternative == null) throw new IllegalArgumentException();
        if(alternatives.contains(alternative)){
            alternatives.remove(alternative);
            project.removeRecentArtifact(alternative);
        }
    }

    public Set getAssumptions() {
        return assumptions;
    }
    public Assumption getAssumptionById(Long id){
        Iterator i = assumptions.iterator();
        Assumption chosenAssumption = null;
        while(i.hasNext()){
            Assumption s = (Assumption) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenAssumption = s;
            }
        }
        return chosenAssumption;
    }
    public void setAssumptions(Set assumptions) {
        this.assumptions = assumptions;
    }
    
   public void addAssumption(Assumption assumption){
        if(assumption == null) throw new IllegalArgumentException();
        if(!(assumptions.contains(assumption))){
            assumptions.add(assumption);
            project.addRecentArtifact(assumption);
        }
    }
    public void removeAssumption(Assumption assumption){
        if(assumption == null) throw new IllegalArgumentException();
        if(assumptions.contains(assumption)){
            assumptions.remove(assumption);
            project.removeRecentArtifact(assumption);
        }
    }
    public Set getDebates() {
        return debates;
    }
    public Debate getDebateById(Long id){
        Iterator i = debates.iterator();
        Debate chosenDebate = null;
        while(i.hasNext()){
            Debate s = (Debate) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenDebate = s;
            }
        }
        return chosenDebate;
    }
    public void setDebates(Set debates) {
        this.debates = debates;
    }

   public void addDebate(Debate debate){
        if(debate == null) throw new IllegalArgumentException();
        if(!(debates.contains(debate))){
            debates.add(debate);
            project.addRecentArtifact(debate);
        }
    }
    public void removeDebate(Debate debate){
        if(debate == null) throw new IllegalArgumentException();
        if(debates.contains(debate)){
            debates.remove(debate);
            project.removeRecentArtifact(debate);
        }
    }
    public Set getDecisions() {
        return decisions;
    }
    public Decision getDecisionById(Long id){
        Iterator i = decisions.iterator();
        Decision chosenDecision = null;
        while(i.hasNext()){
            Decision s = (Decision) i.next();
            if(s.getId().longValue() == id.longValue()){
                chosenDecision = s;
            }
        }
        return chosenDecision;
    }
    public void setDecisions(Set decisions) {
        this.decisions = decisions;
    }
    
   public void addDecision(Decision decision){
        if(decision == null) throw new IllegalArgumentException();
        if(!(decisions.contains(decision))){
            decisions.add(decision);
            project.addRecentArtifact(decision);
        }
    }
    public void removeDecision(Decision decision){
        if(decision == null) throw new IllegalArgumentException();
        if(decisions.contains(decision)){
            decisions.remove(decision);
            project.removeRecentArtifact(decision);
        }
    }
    public ArrayList getArtifactTitles() {
        return artifactTitles;
    }

    public HashMap getProperties() {
        return properties;
    }

    public void setProperties(HashMap properties) {
        this.properties = properties;
    }

    public ArrayList getTraces() {
        return traces;
    }

    public void setTraces(ArrayList traces) {
        this.traces = traces;
    }
}
