/*
 * ProgrammingClass.java
 *
 * Created on 12. mai 2007, 18:07
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.util.HashMap;
import java.util.Iterator;

/**
 *
 * @author Gyrd Norvoll
 */
public class ProgrammingClass extends SystemComponent {
    public static final String recognizer = "Class";
    
    private String implementationLanguage;
    private Package containingPackage;
    private Stakeholder authoringStakeholder;
    
    /**
     * Creates a new instance of ProgrammingClass
     */
    public ProgrammingClass() {
        super(recognizer);
        buildModel();
    }
    private void buildModel(){
         HashMap t = new HashMap();
        t.put("recognizer", no.traceme.model.Package.recognizer);
        t.put("object", containingPackage);
        t.put("trace", "contains");
        getConnectedArtifactCategories().add(t);
        
        t = new HashMap();
        t.put("recognizer", no.traceme.model.Stakeholder.recognizer);
        t.put("object", authoringStakeholder);
        t.put("trace", "authors");
        getConnectedArtifactCategories().add(t);
    }

    public Package getContainingPackage() {
        return containingPackage;
    }

    public void setContainingPackage(Package containingPackage) {
        this.containingPackage = containingPackage;
        Iterator i = getConnectedArtifactCategories().iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("Package")){
                m.put("object", containingPackage);
            }
            
        }
    }

    public Stakeholder getAuthoringStakeholder() {
        return authoringStakeholder;
    }

    public void setAuthoringStakeholder(Stakeholder authoringStakeholder) {
        this.authoringStakeholder = authoringStakeholder;
        Iterator i = getConnectedArtifactCategories().iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("Stakeholder")){
                m.put("object", authoringStakeholder);
            }
            
        }
    }

    public String getImplementationLanguage() {
        return implementationLanguage;
    }

    public void setImplementationLanguage(String implementationLanguage) {
        this.implementationLanguage = implementationLanguage;
    }
    public String toString(){
        return "Class";
    }
}
