/*
 * RequirementDescriptor.java
 *
 * Created on 1. mai 2007, 12:23
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;

/**
 *
 * @author Gyrd Norvoll 
 */
public class RequirementDescriptor extends Artifact implements Serializable {
    public static final String recognizer = "RequirementDescriptor";
    public static final String traceabilityStage = "pre_rs";
    private String classType = recognizer;
    
    private String location;
    private String type;
    
    private ArrayList connectedArtifactCategories = new ArrayList();
    
    private Stakeholder authoringStakeholder;
    private Requirement describedRequirement;
    
    /** Creates a new instance of RequirementDescriptor */
    public RequirementDescriptor() {
        super(recognizer, traceabilityStage, new Date());
        buildModel();
    }

   
    public RequirementDescriptor(Long id, String tag, String location, Stakeholder authoringStakeholder){
        super(id, tag, traceabilityStage, recognizer, new Date());
        this.location = location;
        this.authoringStakeholder = authoringStakeholder;
        buildModel();
    }
    private void buildModel(){
         HashMap t = new HashMap();
        t.put("recognizer", no.traceme.model.Stakeholder.recognizer);
        t.put("object", authoringStakeholder);
        t.put("trace", "authors");
        getConnectedArtifactCategories().add(t);
        
        t = new HashMap();
        t.put("recognizer", no.traceme.model.Requirement.recognizer);
        t.put("object", describedRequirement);
        t.put("trace", "is described by");
        getConnectedArtifactCategories().add(t);
    }
    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public Stakeholder getAuthoringStakeholder() {
        return authoringStakeholder;
    }

    public void setAuthoringStakeholder(Stakeholder authoringStakeholder) {
        this.authoringStakeholder = authoringStakeholder;
        Iterator i = connectedArtifactCategories.iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("Stakeholder")){
                m.put("object", authoringStakeholder);
            }
            
        }
    }
     public Requirement getDescribedRequirement() {
        return describedRequirement;
    }

    public void setDescribedRequirement(Requirement describedRequirement) {
        this.describedRequirement = describedRequirement;
        Iterator i = connectedArtifactCategories.iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("Requirement")){
                m.put("object", describedRequirement);
            }
            
        }
    }
    
   public String toString(){
       return "Requirement descriptor";
   }

    public ArrayList getConnectedArtifactCategories() {
        return connectedArtifactCategories;
    }

    public void setConnectedArtifactCategories(ArrayList connectedArtifactCategories) {
        this.connectedArtifactCategories = connectedArtifactCategories;
    }

    public String getClassType() {
        return classType;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }
}
