/*
 * SystemComponent.java
 *
 * Created on 12. mai 2007, 17:15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;

/**
 *
 * @author Gyrd Norvoll 
 */
public abstract class SystemComponent extends Artifact implements Serializable {
    
    public static final String recognizer = "SystemComponent";
    public static final String traceabilityStage = "post_frs";
    private String classType;
    
    private String title;
    private String description;
    private String location;
    
    private FormalRequirement fulfilledFormalRequirement;
    private ExternalSystem requiredExternalSystem;
    private Design definingDesign;
    
    private ArrayList connectedArtifactCategories = new ArrayList();
    
    /** Creates a new instance of SystemComponent */
    public SystemComponent(String rec) {
        super(rec, traceabilityStage, new Date());
        classType= rec;
        buildModel();
    }
    public SystemComponent(Long id, String tag, String title, String description, String rec){
        super(id, tag, traceabilityStage, rec, new Date());
        classType=rec;
        //this.setTitle(title);
        //this.setDescription(description);
        buildModel();
    }
    private void buildModel(){
        HashMap m = new HashMap();
        m.put("recognizer", no.traceme.model.FormalRequirement.recognizer);
        m.put("object", fulfilledFormalRequirement);
        m.put("trace", "requires");
        getConnectedArtifactCategories().add(m);
        m = new HashMap();
        m.put("recognizer", no.traceme.model.ExternalSystem.recognizer);
        m.put("object", requiredExternalSystem);
        m.put("trace", "depends on");
        getConnectedArtifactCategories().add(m);
        m = new HashMap();
        m.put("recognizer", no.traceme.model.Design.recognizer);
        m.put("object", definingDesign);
        m.put("trace", "is defined by");
        getConnectedArtifactCategories().add(m);
        
    }

    public String getClassType() {
        return classType;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public FormalRequirement getFulfilledFormalRequirement() {
        return fulfilledFormalRequirement;
    }

    public void setFulfilledFormalRequirement(FormalRequirement fulfilledFormalRequirement) {
        this.fulfilledFormalRequirement = fulfilledFormalRequirement;
        Iterator i = connectedArtifactCategories.iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("FormalRequirement")){
                m.put("object", fulfilledFormalRequirement);
            }
            
        }
    }

    public ExternalSystem getRequiredExternalSystem() {
        return requiredExternalSystem;
    }

    public void setRequiredExternalSystem(ExternalSystem dependingExternalSystem) {
        this.requiredExternalSystem = requiredExternalSystem;
        Iterator i = connectedArtifactCategories.iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("ExternalSystem")){
                m.put("object", dependingExternalSystem);
            }
            
        }
    }

    public ArrayList getConnectedArtifactCategories() {
        return connectedArtifactCategories;
    }

    public void setConnectedArtifactCategories(ArrayList connectedArtifactCategories) {
        this.connectedArtifactCategories = connectedArtifactCategories;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public Design getDefiningDesign() {
        return definingDesign;
    }

    public void setDefiningDesign(Design definingDesign) {
        this.definingDesign = definingDesign;
        Iterator i = connectedArtifactCategories.iterator();
        while(i.hasNext()){
            HashMap m = (HashMap) i.next();
            if(m.get("recognizer").toString().equalsIgnoreCase("Design")){
                m.put("object", definingDesign);
            }
            
        }
    }
    public String toString(){
        return "System Component";
    }
}
