/*
 * Design.java
 *
 * Created on 12. mai 2007, 17:15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package no.traceme.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author Gyrd Norvoll 
 */
public abstract class VerificationProcedure extends Artifact implements Serializable {
        
    public static final String recognizer = "VerificationProcedure";
    public static final String traceabilityStage = "post_frs";
    private String classType;
    
    private String name;
    private String location;
    private String description;
    
    private Set targetedFormalRequirements = new HashSet();
    
    
    private ArrayList connectedArtifactCategories = new ArrayList();
    
    /** Creates a new instance */
    public VerificationProcedure(String rec) {
        super(rec, traceabilityStage, new Date());
        classType = rec;
        buildModel();
    }
    public VerificationProcedure(Long id, String tag, String name, String description, String rec){
        super(id, tag, traceabilityStage, rec, new Date());
        classType = rec;
        this.setName(name);
        this.setDescription(description);
        buildModel();
    }
    private void buildModel(){
        HashMap m = new HashMap();
        m.put("recognizer", no.traceme.model.FormalRequirement.recognizer);
        m.put("set", targetedFormalRequirements);
        m.put("trace", "is verified by");
        getConnectedArtifactCategories().add(m);
        
    }

    public String getClassType() {
        return classType;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public ArrayList getConnectedArtifactCategories() {
        return connectedArtifactCategories;
    }

    public void setConnectedArtifactCategories(ArrayList connectedArtifactCategories) {
        this.connectedArtifactCategories = connectedArtifactCategories;
    }

    public Set getTargetedFormalRequirements() {
        return targetedFormalRequirements;
    }

    public void setTargetedFormalRequirements(Set targetedFormalRequirements) {
        this.targetedFormalRequirements = targetedFormalRequirements;
        
    }
    public void addTargetedFormalRequirement(FormalRequirement targetedFormalRequirement){
        if(targetedFormalRequirement == null) throw new IllegalArgumentException();
        if(!(targetedFormalRequirements.contains(targetedFormalRequirement))){
            targetedFormalRequirements.add(targetedFormalRequirement);
        }
    }
    public void removeTargetedFormalRequirement(FormalRequirement targetedFormalRequirement){
        if(targetedFormalRequirement == null) throw new IllegalArgumentException();
        if(targetedFormalRequirements.contains(targetedFormalRequirement)){
            targetedFormalRequirements.remove(targetedFormalRequirement);
        }
    }
    
    public String toString(){
        return "Verification Procedure";
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    
}
