/**
 * ResourceManagerListener.java
 *
 * Created on 2. mai 2007, 08:16
 */

package no.traceme.servlets;

//import no.ntnu.idi.miniTrace.persistence.HibernateUtil;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import no.traceme.model.*;
import javax.servlet.*;

/**
 *
 * @author Gyrd Norvoll 
 * @version
 */
public class ResourceManagerListener implements ServletContextListener {
    
   public void contextInitialized(ServletContextEvent sce){
       ServletContext application = sce.getServletContext();
       
       //##################### setup data ############################
       
       //ProjectList projectList = new ProjectList();
       //UserList userList = new UserList();
       UserList userList = new UserList();
       ProjectList projectList = new ProjectList();
       
       User user = new User(new Long(1), "lassard", "user", false);
       user.setName("Steve Lassard");
       userList.addUser(user);
       User admin = new User( new Long(2), "swifton", "admin", true);
       admin.setName("Bella Swifton");
       userList.addUser(admin);
       User rt_admin = new User( new Long(3), "wilson", "admin", true);
       rt_admin.setName("Thumbelina Wilson");
       userList.addUser(rt_admin);
       User rt_poxenham = new User( new Long(4), "poxenham", "user", false);
       rt_poxenham.setName("Gretchen Poxenham");
       userList.addUser(rt_poxenham);
       User rt_lockhart = new User( new Long(5), "lockhart", "user", false);
       rt_lockhart.setName("Guilderoy Lockhart");
       userList.addUser(rt_lockhart);
       
       
       
       Project testProject = new Project(new Long(001), "The Great Test Project", new Date());
       testProject.setProjectDescription("The Great Test Project's aim is to develop a testing harness that can be adapted to any software application in existence.");
       //testProject.addUserToProject(user);
       testProject.addUserToProject(admin);
       testProject.setProjectManager(user);
       
       
       Project gameProject = new Project(new Long(002), "The Ultimate Game", new Date());
       gameProject.setProjectDescription("Aims to develop the greatest game ever, with functionality for multiple online users, and support for all game consoles on the market.");
       gameProject.addUserToProject(user);
       gameProject.setProjectManager(user);
       
       
       
       
       
       //############################# project-specific data ##################################
       
       Stakeholder stakeholder1 = new Stakeholder(new Long(001), "Stakeholder.GreatConsultantsFirm.Lassard.Steve", "Steve Lassard", "Senior Consultant", "Medium", "External", "1012324", "steve@lassard.com", "F-G-132", "Great Consultants Firm");
       Stakeholder stakeholder2 = new Stakeholder(new Long(002), "Stakeholder.FictitiousFirm.Poxenham.Gretchen", "Gretchen Poxenham", "Project Manager", "High", "Internal", "104322324", "gretchen@fictitious.com", "F-G-332", "Fictitious Firm");
       Stakeholder stakeholder3 = new Stakeholder(new Long(003), "Stakeholder.FictitiousFirm.Wilson.Thumbelina", "Thumbelina Wilson", "Assistant project manager", "Medium", "Internal", "48396857", "thumbelina@fictitious.com", "F-G-333", "Fictitious Firm");
       Stakeholder stakeholder4 = new Stakeholder(new Long(004), "Stakeholder.GreatConsultantsFirm.Baggins.Frodo", "Frodo Baggins", "Junior Consultant", "Low", "External", "28394716", "frodo@baggins.com", "F-G-133", "Great Consultants Firm");
       
       
       gameProject.getPreRSContainer().addStakeholder(stakeholder2);
       gameProject.getPreRSContainer().addStakeholder(stakeholder3);
       testProject.getPreRSContainer().addStakeholder(stakeholder1);
       testProject.getPreRSContainer().addStakeholder(stakeholder4);
       
       Requirement req1 = new Requirement(new Long(001), "Requirement.Prose.GUI.Window", "Window-based GUI", "All GUI must be window-based, like in Windows");
       Requirement req2 = new Requirement(new Long(002), "Requirement.Prose.GUI.UserFriendly", "User-friendly application", "The application must be user-friendly");
       Requirement req3 = new Requirement(new Long(003), "Requirement.Prose.Performance.Latency", "Request Latency", "The latency of user request must not cause the user to be exhausted");
       Requirement req4 = new Requirement(new Long(004), "Requirement.Prose.Performance.Throughput", "Request Throughput", "The throughput of user requests must be darn high!");
       Requirement req5 = new Requirement(new Long(005), "Requirement.Prose.GameHighScore", "Highscore", "A highscore of the best scores in the game must be maintained.");
       
       req1.setOwningStakeholder(stakeholder4);
       req2.setOwningStakeholder(stakeholder1);
       req3.setOwningStakeholder(stakeholder4);
       req4.setOwningStakeholder(stakeholder2);
       req5.setOwningStakeholder(stakeholder3);
       
       req1.addAffectedStakeholder(stakeholder1);
       req1.addAffectedStakeholder(stakeholder4);
      
       ChangeProposal cp1 = new ChangeProposal(new Long(1), "ChangeProposal.Prose.GUI", "The GUI should not resemble Windows, we could get sued.", stakeholder1, req1);
       ChangeProposal cp2 = new ChangeProposal(new Long(2), "ChangeProposal.Functional.GameHighScore.PlayerNames", "Should the Game High Score not only keep track of the best scores, but the names of the best players?", stakeholder2, req5);

       
       cp1.approveChangeProposal();
      
       gameProject.getPreRSContainer().addChangeProposal(cp1);
       testProject.getPreRSContainer().addChangeProposal(cp2);

       
       gameProject.getPreRSContainer().addRequirement(req1);
       gameProject.getPreRSContainer().addRequirement(req2);
       gameProject.getPreRSContainer().addRequirement(req3);
       testProject.getPreRSContainer().addRequirement(req4);
       testProject.getPreRSContainer().addRequirement(req5);
       
       Rationale rat1 = new Rationale(new Long(1), "Rationale.WindowBasedGUI", "Most users are already accustomed to a window-based gui");
       rat1.addAffectedRequirement(req1);
      
       gameProject.getPreRSContainer().addRationale(rat1);
       
       
       //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% RT tool project %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       
       Project rtProject = new Project(new Long(3), "TraceMe RT tool", new Date());
       rtProject.setProjectDescription("A tool for registering requirements and all other artifacts of the software development processes, registering vital traceability information throughout the registration processes, thus enabling the user to trace between the artifacts of a software development project.");
       rtProject.addUserToProject(rt_admin);
       rtProject.addUserToProject(rt_lockhart);
       rtProject.addUserToProject(rt_poxenham);
       rtProject.setProjectManager(rt_admin);
       
       
       Stakeholder rt_stakeholder1 = new Stakeholder(new Long(11), "Stakeholder.Architect", "Thomas Crown", "Senior Architect", "High", "Internal", "1012324", "thomas.crown@fictitiousfirm.com", "F-G-132", "Fictitious Firm");
       Stakeholder rt_stakeholder2 = new Stakeholder(new Long(12), "Stakeholder.Designer", "Peter Parker", "Senior Consultant", "Medium", "External", "104322324", "peter.parker@greatconsultants.com", "F-G-332", "Great Consultants");
       Stakeholder rt_stakeholder3 = new Stakeholder(new Long(13), "Stakeholder.Developer", "Clark Kent", "Junior Consultant", "Low", "External", "48396857", "clark.kent@greatconsultants.com", "F-G-333", "Great Consultants");
       Stakeholder rt_stakeholder4 = new Stakeholder(new Long(14), "Stakeholder.Tester", "Aeon Flux", "Test manager", "Medium", "Internal", "28394716", "aeon.flux@fictitiousfirm.com", "F-G-133", "Fictitious Firm");
       
       
       rtProject.getPreRSContainer().addStakeholder(rt_stakeholder2);
       rtProject.getPreRSContainer().addStakeholder(rt_stakeholder3);
       rtProject.getPreRSContainer().addStakeholder(rt_stakeholder1);
       rtProject.getPreRSContainer().addStakeholder(rt_stakeholder4);
       
       Requirement rt_req1 = new Requirement(new Long(1), "Requirement.Prose.ExternalInterface.UserInterface.Feedback", "Task feedback", "Each task must when completed provide the user with feedback describing the results of the previous user action.");
       Requirement rt_req2 = new Requirement(new Long(2), "Requirement.Prose.ExternalInterface.UserInterface.Navigation", "Navigation", "The user must be able to navigate within the system.");
       Requirement rt_req3 = new Requirement(new Long(3), "Requirement.Prose.ExternalInterface.UserInterface.Navigation.Location", "Location within system", "The user must at all times be notified of the current location within the system, also know as the current path.");
       Requirement rt_req4 = new Requirement(new Long(4), "Requirement.Prose.ExternalInterface.UserInterface.Navigation.Escape", "Escaping system tasks", "The system must always provide the user with navigation possibilities for escaping tasks in progress.");
       
       ExternalInterfaceRequirement re_eir1 = new ExternalInterfaceRequirement();
       re_eir1.setId(new Long(1));
       re_eir1.setTag("FormalRequirement.ExternalInterfaceRequirement.UserInterface.Feedback");
       re_eir1.setTitle("Feedback");
       re_eir1.setDescription("The user must be given feedback on all actions taken within the system, in the form of feedback messages, indicating either a successful operation, or if not, indicating what went wrong and how it should be corrected.");
       System.out.println("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&" + re_eir1.recognizer);
       FormalRequirement fr = (FormalRequirement) re_eir1;
       System.out.println("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&"+ fr.getChildType());
       
       re_eir1.setDefiningProseRequirement(rt_req1);
       rtProject.getPreFRSContainer().addFormalRequirement(re_eir1);
       
       rt_req1.setOwningStakeholder(rt_stakeholder1);
       rt_req2.setOwningStakeholder(rt_stakeholder2);
       rt_req3.setOwningStakeholder(rt_stakeholder1);
       rt_req4.setOwningStakeholder(rt_stakeholder2);
       
       rt_req1.addAffectedStakeholder(rt_stakeholder2);
       rt_req1.addAffectedStakeholder(rt_stakeholder3);
       rt_req1.addAffectedStakeholder(rt_stakeholder4);
       
       rt_req2.addAffectedStakeholder(rt_stakeholder2);
       rt_req2.addAffectedStakeholder(rt_stakeholder3);
       
       rt_req3.addAffectedStakeholder(rt_stakeholder3);
       rt_req3.addAffectedStakeholder(rt_stakeholder4);
       
       rt_req4.addAffectedStakeholder(rt_stakeholder3);
       rt_req4.addAffectedStakeholder(rt_stakeholder4);
       
       rtProject.getPreRSContainer().addRequirement(rt_req4);
       rtProject.getPreRSContainer().addRequirement(rt_req3);
       rtProject.getPreRSContainer().addRequirement(rt_req2);
       rtProject.getPreRSContainer().addRequirement(rt_req1);
       
       RequirementDescriptor rt_rd1 = new RequirementDescriptor(new Long(1), "RequirementDescriptor.UML.ClassDiagram", "/root/traceme_rt/requirement_descriptors/UML_class_diagram.png", rt_stakeholder1);
       RequirementDescriptor rt_rd2 = new RequirementDescriptor(new Long(2), "RequirementDescriptor.UML.DeploymentDiagram", "/root/traceme_rt/requirement_descriptors/UML_class_diagram.png", rt_stakeholder1);
       
       req1.addRequirementDescriptor(rt_rd1);
       req2.addRequirementDescriptor(rt_rd2);
       
       rtProject.getPreRSContainer().addRequirementDescriptor(rt_rd1);
       rtProject.getPreRSContainer().addRequirementDescriptor(rt_rd2);
       
       ChangeProposal rt_cp1 = new ChangeProposal(new Long(1), "ChangeProposal.ExternalInterface.UserInterface.Location", "The user should also be able to locate functionalities within the system by browsing an application map, also known as a website map.", rt_stakeholder3, rt_req3);
       ChangeProposal rt_cp2 = new ChangeProposal(new Long(2), "ChangeProposal.ExternalInterface.UserInterface.Feedback", "Feedback should be presented to the user through informative messages, both relating what went wrong, and how this could be fixed.", rt_stakeholder4, rt_req1);
       
       rt_cp1.approveChangeProposal();
       
       rtProject.getPreRSContainer().addChangeProposal(rt_cp1);
       rtProject.getPreRSContainer().addChangeProposal(rt_cp2);
       
       Rationale rt_rat1 = new Rationale(new Long(1), "Rationale.ChangeProposal.ExternalInterface.UserInterface.Feedback", "Informative feedback messages helps the user understand what went wrong, so that the mistake won't be repeated.");
       rt_rat1.addAffectedChangeProposal(rt_cp2);
       
       rtProject.getPreRSContainer().addRationale(rt_rat1);
       
      Issue rt_iss1 = new Issue(new Long(1), "Issue.Feedback", "Providing to much feedback, and we risk annoying the user significantly, thus reducing the perceived usability of the system.");
      
      rt_iss1.setGeneratingRequirement(rt_req1);
      
      Debate rt_deb1 = new Debate(new Long(1), "Debate.Feedback", "Discussing the intrusiveness and degree of required user feedback");
      rt_deb1.setStartingIssue(rt_iss1);
      
      Alternative rt_alt1 = new Alternative(new Long(1), "Alternative.MessageBoxes", "By using message boxes we can inform the user only when things go wrong.", rt_stakeholder1);
      Alternative rt_alt2 = new Alternative(new Long(2), "Alternative.ErrorPages", "Error pages leaves room for more information other than just informing the user that something went wrong.", rt_stakeholder3);
      rt_deb1.addAlternative(rt_alt1);
      rt_deb1.addAlternative(rt_alt2);
      
      rtProject.getPreRSContainer().addAlternative(rt_alt1);
      rtProject.getPreRSContainer().addAlternative(rt_alt2);
      
      Decision rt_dec1 = new Decision(new Long(1), "Decision.Feedback", "Error pages will be used to inform the user of the result of his or her actiosn, and if something went wrong.", "The decision was made in unison after lengthy discussions among project members.", new Date());
      stakeholder1.addReachedDecision(rt_dec1);
      rt_iss1.resolveIssue(rt_dec1);
      
       rtProject.getPreRSContainer().addIssue(rt_iss1);
       rtProject.getPreRSContainer().addDebate(rt_deb1);
       rtProject.getPreRSContainer().addDecision(rt_dec1);
       
       FunctionalRequirement rt_funcreq1 = new FunctionalRequirement();
       rt_funcreq1.setId(new Long(2));
       rt_funcreq1.setTag("Formal.Functional.WorkingWithProjects.ExitProject");
       rt_funcreq1.setPriority("High");
       rt_funcreq1.setRisk("High");
       rt_funcreq1.setTitle("Exit project");
       rt_funcreq1.setGist("Exiting the project one is currently working on.");
       rt_funcreq1.setStatus("In development");
       rt_funcreq1.setDescription("The user must be able to quit working with a specific project, thus escaping the project.");
       rt_req4.addFormalRequirement(rt_funcreq1);
       
       FunctionalRequirement rt_funcreq2 = new FunctionalRequirement();
       rt_funcreq2.setId(new Long(3));
       rt_funcreq2.setTag("Formal.Functional.WorkingWithProjects.DetermineTraceabilityStage");
       rt_funcreq2.setDescription("The user must be able to switch between the traceability stages of the traceability model, i.e. between the pre-RS traceability, pre-FRS traceability, and post-FRS traceability stage.");
       rt_funcreq2.setPriority("High");
       rt_funcreq2.setRisk("High");
       rt_funcreq2.setTitle("Determine traceability stage");
       rt_funcreq2.setGist("Switching between traceability stages.");
       rt_funcreq2.setStatus("Deployed");
       rt_req3.addFormalRequirement(rt_funcreq2);
       
       FunctionalRequirement rt_funcreq3 = new FunctionalRequirement();
       rt_funcreq3.setId(new Long(4));
       rt_funcreq3.setTag("Formal.Functional.WorkingWithProjects.Navigation");
       rt_funcreq2.setPriority("High");
       rt_funcreq2.setRisk("High");
       rt_funcreq2.setTitle("Navigation");
       rt_funcreq2.setGist("Navigating within the system");
       rt_funcreq2.setStatus("Approved");
       rt_funcreq3.setDescription("The user must be able to navigate to all functions existing within the application.");
       
       rt_req2.addFormalRequirement(rt_funcreq3);
       
       PerformanceRequirement rt_perfreq1 = new PerformanceRequirement();
       rt_perfreq1.setId(new Long(5));
       rt_perfreq1.setTag("Formal.Performance.Througput.ActiveUsers");
       rt_perfreq1.setTitle("Throughput: Number of simulatenously active users");
       rt_perfreq1.setDescription("The system must support at least 50 simultaneously active users, where an active user represents a logged-in user performing tasks within the system.");
       rt_perfreq1.setGist("At least 50 simultaneous users of the application.");
       rt_perfreq1.setMeter("N/A");
       rt_perfreq1.setScale("Number of simultaneously active users");
       rt_perfreq1.setAmbition("A high level of simultaneous users, without violating any other performance requirements.");
       rt_perfreq1.setTargets("70", "100", "150");
       rt_perfreq1.setBenchmarks("N/A", "N/A", "N/A");
       rt_perfreq1.setConstraints("40", "30");
       rt_perfreq1.setPriority("High");
       rt_perfreq1.setRisk("Medium");
       rt_perfreq1.setStatus("Under development");
       rt_req1.addFormalRequirement(rt_perfreq1);
       
       SoftwareSystemAttribute rt_ssa1 = new SoftwareSystemAttribute();
       rt_ssa1.setId(new Long(6));
       rt_ssa1.setTag("Formal.Attribute.Modifiability.Flexibility");
       rt_ssa1.setTitle("Flexibility");
       rt_ssa1.setGist("Displayed information must be adaptable at runtime.");
       rt_ssa1.setDescription("The visualisations of trace information must in normal system operation mode be adaptable by the users of the system, allowing system flexibility.");
       rt_ssa1.setAmbition("The system must be flexible in order to accommodate users in a wide range of working situations.");
       rt_ssa1.setScale("Invested user effort, measured in simple user operations (e.g. a mouse click or a keystroke), for adapting trace information to current working situation.");
       rt_ssa1.setMeter("N/A");
       rt_ssa1.setConstraints("10 simple user operations", "15 simple user operations");
       rt_ssa1.setBenchmarks("N/A", "N/A", "N/A");
       rt_ssa1.setTargets("Maximum 6 simple user operations", "Maximum 4 simple user operations", "Maximum 2 simple user operations");
       rt_ssa1.setPriority("High");
       rt_ssa1.setRisk("Medium");
       rt_ssa1.setStatus("Under development");
       rt_req2.addFormalRequirement(rt_ssa1);
       
       rtProject.getPreFRSContainer().addFormalRequirement(rt_funcreq1);
       rtProject.getPreFRSContainer().addFormalRequirement(rt_funcreq2);
       rtProject.getPreFRSContainer().addFormalRequirement(rt_funcreq3);
       rtProject.getPreFRSContainer().addFormalRequirement(rt_perfreq1);
       rtProject.getPreFRSContainer().addFormalRequirement(rt_ssa1);
       
       Design rt_des1 = new Design();
       rt_des1.setId(new Long(1));
       rt_des1.setTag("Design.LogicalDesign.ClassDiagram");
       rt_des1.setTitle("Logical design");
       rt_des1.setType("UML class diagram");
       rt_des1.setDescription("Class diagram depicting the logical design of the application, for use in the logical view of the architectural description.");
       rt_des1.setLocation("/root/designs/logical/classdiagram.png");
       rt_funcreq1.addDesign(rt_des1);
       rt_funcreq2.addDesign(rt_des1);
       
       
       no.traceme.model.Package rt_pack1 = new no.traceme.model.Package();
       rt_pack1.setId(new Long(1));
       rt_pack1.setTag("SystemComponent.Package.Controller");
       rt_pack1.setDescription("Contains classes for controlling the application, involving aspects such as referring the user requests to proper recipients..");
       rt_pack1.setFulfilledFormalRequirement(rt_funcreq3);
       
       ProgrammingClass rt_class1 = new ProgrammingClass();
       rt_class1.setId(new Long(2));
       rt_class1.setTag("SystemComponent.Class.MainController");
       rt_class1.setDescription("The MainController serves as the front end facing the user, receiving all requests and sorting them to their proper recipient with the help of a dispatcher.");
       rt_class1.setImplementationLanguage("Java EE");
       rt_class1.setAuthoringStakeholder(rt_stakeholder3);
       
       ProgrammingClass rt_class2 = new ProgrammingClass();
       rt_class2.setId(new Long(3));
       rt_class2.setTag("SystemComponent.Class.Dispatcher");
       rt_class2.setDescription("The Dispatcher helps the controller with determining which recipient should receive which request.");
       rt_class2.setImplementationLanguage("Java EE");
       rt_class2.setAuthoringStakeholder(rt_stakeholder3);
       
       rt_pack1.addProgrammingClass(rt_class1);
       rt_pack1.addProgrammingClass(rt_class2);
       
       rt_des1.addDefinedSystemComponent(rt_pack1);
       
       rtProject.getPostFRSContainer().addDesign(rt_des1);
       rtProject.getPostFRSContainer().addSystemComponent(rt_pack1);
       rtProject.getPostFRSContainer().addSystemComponent(rt_class1);
       rtProject.getPostFRSContainer().addSystemComponent(rt_class2);
       
       //################################## adding to scope #######################################
       
       projectList.addProject(testProject);
       //application.setAttribute("testProject", testProject);
       projectList.addProject(gameProject);
       //application.setAttribute("gameProject", gameProject);
       projectList.addProject(rtProject);
       
       application.setAttribute("pList", projectList);
       application.setAttribute("uList", userList);
   }
   public void contextDestroyed(ServletContextEvent sce){
       ServletContext application = sce.getServletContext();
       //application.removeAttribute("hibernateUtil");
   }
}
