<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html id="leftbar">
    <head>
        <link rel="stylesheet" type="text/css" href="/traceme/traceme_styles.css"></link>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>TraceMe - Project details</title>
    </head>
    <body>
    
    <%@ include file="/WEB-INF/jspf/main_banner.jspf" %>
    <%@ include file="/WEB-INF/jspf/main_navigation.jspf" %>

    
    <jsp:useBean id="pList" scope="application" class="no.traceme.model.ProjectList"/>
    <jsp:useBean id="uList" scope="application" class="no.traceme.model.UserList"/>

    <!-- Creating a new project-->
                <c:if test="${param.projectTitle != null}">
                    <jsp:useBean id="newProject" scope="page" class="no.traceme.model.Project"/>
                    <jsp:setProperty name="newProject" property="id" param="chosenProjectId"/>
                    <jsp:setProperty name="newProject" property="projectTitle" param="projectTitle"/>
                    <jsp:setProperty name="newProject" property="projectDescription" param="description"/>
                    
                    
                    <c:forEach var="elem" items="${uList.userList}">
                    <c:if test="${elem.id == param.projectManager}">
                        <c:set var="user" scope="page" value="${elem}"/>
                    </c:if>
                    </c:forEach>
                    <%  newProject.addUserToProject((no.traceme.model.User)pageContext.getAttribute("user"));
                        newProject.setProjectManager((no.traceme.model.User)pageContext.getAttribute("user"));
                        newProject.setStartDate(new java.util.Date());
                        pList.addProject(newProject); 
                    %>
                </c:if>
                
    <!-- Setting the current chosenProject-->            
                
        <c:forEach var="elem" items="${pList.projectList}">
            <c:if test="${elem.id == param.chosenProjectId}">
                <c:set var="chosenProject" scope="application" value="${elem}"/>
            </c:if>
        </c:forEach>
        
    <jsp:useBean id="chosenProject" scope="application" class="no.traceme.model.Project"/>
    
    <!-- Attaching a user to the project-->
    <c:if test="${param.attachedUser != null}">
        <c:forEach var="elem" items="${uList.userList}">
            <c:if test="${elem.id == param.attachedUser}">
                <c:set var="attacheduser" scope="page" value="${elem}"/>
            </c:if>
        </c:forEach>
        <% chosenProject.addUserToProject((no.traceme.model.User)pageContext.getAttribute("attacheduser"));%>
    </c:if>
     <!-- Removing a user from the project-->
    <c:if test="${param.removedUser != null}">
        <c:forEach var="elem" items="${uList.userList}">
            <c:if test="${elem.id == param.removedUser}">
                <c:set var="removeduser" scope="page" value="${elem}"/>
            </c:if>
        </c:forEach>
        <% chosenProject.removeUserFromProject((no.traceme.model.User)pageContext.getAttribute("removeduser"));%>
    </c:if>
    <div id="taskbar">
        <a href="/traceme/tool/index.jsp">Open contents</a> | 
        <a href="/traceme/project/editproject.jsp">Edit project</a> | 
        <a href="/traceme/project/deleteproject.jsp">Delete project</a> | 
        <a href="/traceme/project/attachuser.jsp?chosenProjectId=${param.chosenProjectId}">Attach user</a> | 
        <a href="/traceme/project/removeuser.jsp?chosenProjectId=${param.chosenProjectId}">Remove user</a>
    </div>
    <div id="main">
    <h2><jsp:getProperty name="chosenProject" property="projectTitle" /></h2>
    
        <h3>Description</h3>
        <jsp:getProperty name="chosenProject" property="projectDescription"/>
        
        <h3>Start date</h3>
        
        <jsp:getProperty name="chosenProject" property="startDate" />
        
        <h3>Attached users</h3>
        
        <c:forEach var="elem" items="${chosenProject.attachedUsers}">
            <a href="/traceme/user/viewuser.jsp?chosenUserId=${elem.id}"><c:out value="${elem.name}"/></a><br/>
        </c:forEach>
        
        <h3>Project manager</h3>
 
        
        <a href="/traceme/user/viewuser.jsp?chosenUserId="<c:out value="${chosenProject.projectManager.id}"/>><c:out value="${chosenProject.projectManager.name}"/></a>
        <br/>
        
    </div>
    
    <%@ include file="/WEB-INF/jspf/main_footer.jspf" %>
    
    </body>
</html>
