<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html id="leftbar">
    <head>
        <link rel="stylesheet" type="text/css" href="/traceme/traceme_styles.css"></link>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>TraceMe - Create artifact - step 2</title>
    </head>
    <body>
    
    <%@ include file="/WEB-INF/jspf/trace_banner_post_frs.jspf" %>
    <%@ include file="/WEB-INF/jspf/trace_navigation.jspf" %>

    <jsp:useBean id="chosenProject" scope="application" class="no.traceme.model.Project"/>
    
    <div id="projectTitle"><jsp:getProperty name="chosenProject" property="projectTitle"/></div>

   
    <!-- Determine selected artifact category-->
<%@ include file="/WEB-INF/jspf/artifacts/taskbar.jspf" %>

   
     
    
    
<c:if test="${param.category == 'Class' || param.category == 'Package' || param.category == 'Component' || param.category == 'Module'}">
        <div id="taskbar3">
            | <a href="/traceme/import_systemcomponent.jsp">Import system component</a>
        </div>
    </c:if>
    
    
    
    <h2>Create artifact - step 2 of 2</h2>
    
    
        
    <form action="createnewartifact_receipt.jsp" method="get">
        <table cellspacing="10px">
            <tr><td>Artifact category:</td><td><input type="text" value="<c:out value="${param.category}"/>" name="artifactCategory"/></td></tr>
            <%
            java.util.HashMap properties = chosenProject.getPostFRSContainer().getProperties();
            //out.print(request.getParameter("category"));
            java.util.ArrayList propertyKeeper = (java.util.ArrayList) properties.get(request.getParameter("category"));
            if(propertyKeeper != null){
            java.util.Iterator i = propertyKeeper.iterator();
            
            
            
            while(i.hasNext()){
                
                String output = "<tr><td valign=\"top\">";
                no.traceme.model.Property property = (no.traceme.model.Property) i.next();
                
                //stakeholders are the only artifacts that is possible to create a combobox of
                        
                if(property.getType().equalsIgnoreCase("Stakeholder") && property.getFormInputType().equalsIgnoreCase("select")){
                    //we're building a combobox of stakeholders
                    
                    java.util.Set stakeholders = (java.util.Set) chosenProject.getPreRSContainer().getStakeholders();
                    java.util.Iterator itr = stakeholders.iterator();
                    output += property.getFormTitle() + ":</td><td><select name=\"" + property.getName() + "\">";
                    while(itr.hasNext()){
                        no.traceme.model.Stakeholder sh = (no.traceme.model.Stakeholder) itr.next();
                        output += "<option value=\"" + sh.getId() + "\">" + sh.getName() + "</option>";
                    }
                    output += "</select>";
                   
                } else if(property.getType().equalsIgnoreCase("Requirement") && property.getFormInputType().equalsIgnoreCase("select")){
                    //we're building a combobox of requirements
                    
                    java.util.Set requirements = (java.util.Set) chosenProject.getPreRSContainer().getRequirements();
                    java.util.Iterator itr = requirements.iterator();
                    output += property.getFormTitle() + ":</td><td><select name=\"" + property.getName() + "\">";
                    while(itr.hasNext()){
                        no.traceme.model.Requirement r = (no.traceme.model.Requirement) itr.next();
                        output += "<option value=\"" + r.getId() + "\">" + r.getTag() + "</option>";
                    }
                    output += "</select>";
                } else if(property.getName().equalsIgnoreCase("location")){
                    //add a browse button                   
                    output += property.getFormTitle() + ":</td><td>";
                    output += "<input type=\"" + property.getFormInputType() + "\" name=\"" + property.getName() + "\" size=\"54\"/><input type=\"reset\" value=\"Browse...\"/>";
                }else if(property.getType().equalsIgnoreCase("FormalRequirement") && property.getFormInputType().equalsIgnoreCase("select")){
                    //we're building a combobox of formal requirements
                    
                    java.util.Set formalRequirements = (java.util.Set) chosenProject.getPreFRSContainer().getFormalRequirements();
                    java.util.Iterator itr = formalRequirements.iterator();
                    output += property.getFormTitle() + ":</td><td><select name=\"" + property.getName() + "\">";
                    while(itr.hasNext()){
                        no.traceme.model.FormalRequirement fr = (no.traceme.model.FormalRequirement) itr.next();
                        output += "<option value=\"" + fr.getId() + "\">" + fr.getTag() + "</option>";
                    }
                    output += "</select>";
                } else if(property.getType().equalsIgnoreCase("SystemComponent") && property.getFormInputType().equalsIgnoreCase("select")){
                    //we're building a combobox of system components
                    
                    java.util.Set systemComponents = (java.util.Set) chosenProject.getPostFRSContainer().getSystemComponents();
                    java.util.Iterator itr = systemComponents.iterator();
                    output += property.getFormTitle() + ":</td><td><select name=\"" + property.getName() + "\">";
                    while(itr.hasNext()){
                        no.traceme.model.SystemComponent sc = (no.traceme.model.SystemComponent) itr.next();
                        output += "<option value=\"" + sc.getId() + "\">" + sc.getTag() + "</option>";
                    }
                    output += "</select>";
                }else if(property.getFormInputType().equalsIgnoreCase("textarea")){
                    output += property.getFormTitle() + ":</td><td>";
                    output += "<textarea name=\"" + property.getName() + "\" rows=\"4\" cols=\"50\"></textarea>";
                }else{
                    output += property.getFormTitle() + ":</td><td>";
                    output += "<input type=\"" + property.getFormInputType() + "\" name=\"" + property.getName() + "\" size=\"67\"/>";
                }
                
                
                
                output += "</td></tr>";
                out.print(output);
            }
            out.print("<tr><td></td><td><input type=\"submit\" value=\"Create\"/></td></tr>");
            out.print("<tr><td colspan=\"2\"><a href=\"createartifact.jsp\">Go back to previous stage</a><td><tr>");
            }
            else {
                out.print("No properties were defined for this artifact.");
                }
            %>
            
            
            
        
        </table>
    </form>
        
        
    
    
    <%@ include file="/WEB-INF/jspf/trace_footer.jspf" %>
    </body>
</html>
