<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html id="leftbar">
    <head>
        <link rel="stylesheet" type="text/css" href="/traceme/traceme_styles.css"></link>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>TraceMe - Connected artifacts</title>
    </head>
    <body>
    
    <%@ include file="/WEB-INF/jspf/trace_banner_post_frs.jspf" %>
    <%@ include file="/WEB-INF/jspf/trace_navigation.jspf" %>
    <%@ include file="/WEB-INF/jspf/traces/taskbar.jspf" %>
    
    <jsp:useBean id="chosenProject" scope="application" class="no.traceme.model.Project"/>
    
    <div id="projectTitle"><jsp:getProperty name="chosenProject" property="projectTitle"/></div>    
       
 <jsp:useBean id="chosenArtifact" scope="application" class="no.traceme.model.Artifact"/>

    
    <h3>Receipt - Creation of trace</h3>
    

    
    <% String endingArtifactType = request.getParameter("endingArtifactType");
        Long startingArtifactId = new Long(request.getParameter("startingArtifactId"));
        Long endingArtifactId = new Long(request.getParameter("endingArtifactId"));
        %>
    
        <c:choose>
            <c:when test="${param.startingArtifactType == 'FormalRequirement'}">
                <% 
                no.traceme.model.FormalRequirement fr = chosenProject.getPreFRSContainer().getFormalRequirementById(startingArtifactId);
                
                if(fr.getChildType().equalsIgnoreCase(no.traceme.model.ExternalInterfaceRequirement.recognizer)){
                        no.traceme.model.ExternalInterfaceRequirement eir = (no.traceme.model.ExternalInterfaceRequirement) fr;
                }else if(fr.getChildType().equalsIgnoreCase(no.traceme.model.FunctionalRequirement.recognizer)){
                    no.traceme.model.FunctionalRequirement eir = (no.traceme.model.FunctionalRequirement) fr;                
                }else if(fr.getChildType().equalsIgnoreCase(no.traceme.model.SoftwareSystemAttribute.recognizer)){
                     no.traceme.model.SoftwareSystemAttribute eir = (no.traceme.model.SoftwareSystemAttribute) fr;
                }else if(fr.getChildType().equalsIgnoreCase(no.traceme.model.DesignConstraint.recognizer)){
                    no.traceme.model.DesignConstraint eir = (no.traceme.model.DesignConstraint) fr;
                }else(/*fr.getChildType().equalsIgnoreCase(no.traceme.model.PerformanceRequirement.recognizer))*/{
                     no.traceme.model.PerformanceRequirement eir = (no.traceme.model.PerformanceRequirement) fr;
                }
                if(endingArtifactType.equalsIgnoreCase("VerificationProcedure")){
                    no.traceme.model.VerificationProcedure vp = chosenProject.getPostFRSContainer().getVerificationProcedureById(endingArtifactId);
                    //if(vp.getChildType().equalsIgnoreCase(no.traceme.model.Prototype.recognizer)){
                    //   no.traceme.model.Prototype prot = (no.traceme.model.Prototype) vp;
                    //  eir.addVerificationProcedure(prot);
                    //}
                    eir.addVerificationProcedure(vp);
                }if(endingArtifactType.equalsIgnoreCase("Design")){
                    no.traceme.model.Design design = chosenProject.getPostFRSContainer().getDesignById(endingArtifactId);                            
                    eir.addDesign(design);
                }
                %>                    
            </c:when>
            <c:when test="${param.startingArtifactType == 'Design'}">
                <% 
                no.traceme.model.Design d = chosenProject.getPostFRSContainer().getDesignById(startingArtifactId);
                if(endingArtifactType.equalsIgnoreCase("SystemComponent")){
                            
                            no.traceme.model.SystemComponent sc = chosenProject.getPostFRSContainer().getSystemComponentById(endingArtifactId);
                            d.addDefinedSystemComponent(sc);
                        }
                %>
            </c:when>
            <c:when test="${param.startingArtifactType == 'ExternalSystem'}">
                <% 
                no.traceme.model.ExternalSystem ex = chosenProject.getPostFRSContainer().getExternalSystemById(startingArtifactId);
                if(endingArtifactType.equalsIgnoreCase("SystemComponent")){
                            
                            no.traceme.model.SystemComponent sc = chosenProject.getPostFRSContainer().getSystemComponentById(endingArtifactId);
                            ex.addDependingSystemComponent(sc);
                        }
                %>
            </c:when>
            <c:when test="${param.startingArtifactType == 'Package'}">
                <% 
                no.traceme.model.Package pack = chosenProject.getPostFRSContainer().getPackageById(startingArtifactId);
                if(endingArtifactType.equalsIgnoreCase("Class")){
                            
                            no.traceme.model.ProgrammingClass c = chosenProject.getPostFRSContainer().getProgrammingClassById(endingArtifactId);
                            pack.addProgrammingClass(c);
                        }
                %>
            </c:when>
            <c:when test="${param.startingArtifactType == 'Test'}">
                <% 
                no.traceme.model.Test test = chosenProject.getPostFRSContainer().getTestById().(startingArtifactId);
                if(endingArtifactType.equalsIgnoreCase("SystemComponent")){
                            
                            no.traceme.model.SystemComponent sc = chosenProject.getPostFRSContainer().getSystemComponentById(endingArtifactId);
                            test.setAffectingSystemComponent(sc);
                        }
                %>
            </c:when>
        </c:choose> 
        
        
        A trace of type <b><i><c:out value="${param.startingArtifactType}"/></i> <c:out value="${param.trace}"/> <i><c:out value="${param.endingArtifactType}"/></i></b> has been created.
        <br/><br/><a href="trace_category.jsp?startingArtifact=<c:out value="${param.startingArtifactType}"/>&endingArtifact=<c:out value="${param.endingArtifactType}"/>&trace=<c:out value="${param.trace}"/>">Click here to find your trace.</a>
        
       
            
        
        
        
    
    <%@ include file="/WEB-INF/jspf/trace_footer.jspf" %>
    </body>
</html>
