<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html id="leftbar">
    <head>
        <link rel="stylesheet" type="text/css" href="/traceme/traceme_styles.css"></link>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>TraceMe - Project details</title>
    </head>
    <body>
    
    <%@ include file="/WEB-INF/jspf/trace_banner_post_frs.jspf" %>
    <%@ include file="/WEB-INF/jspf/trace_navigation.jspf" %>

    <jsp:useBean id="chosenProject" scope="application" class="no.traceme.model.Project"/>
    
    <div id="projectTitle"><jsp:getProperty name="chosenProject" property="projectTitle"/></div>

            
                        
    <!-- Determine selected artifact-->
     <c:forEach var="set" items="${chosenProject.postFRS}">
            <c:forEach var="elem" items="${set}">
                
                <c:if test="${elem.id == param.chosenArtifactId && elem.classType == param.artifactType}">
                    <c:set var="chosenArtifact" scope="application" value="${elem}"/>
                </c:if>
            </c:forEach>
        </c:forEach>
    
    
       
 <jsp:useBean id="chosenArtifact" scope="application" class="no.traceme.model.Artifact"/>
    
<%@ include file="/WEB-INF/jspf/artifacts/taskbar.jspf" %>
    <div id="taskbar3"> | <a href="printrapport.jsp">Print report</a></div>
    
    
        <h3><jsp:getProperty name="chosenArtifact" property="tag"/></h3>
        
        <!-- Here we need some massive identification code, recognising the different artifact types and presenting their properties suitably. 
        Or perhaps simply just an iteration of the properties... possible?
        
        This code must also be altered for the various traceability stages, no point in adding all artifacts everywhere
        -->
        <c:choose>
            <c:when test="${chosenArtifact.childType == 'FunctionalRequirement'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_functionalreq.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'ExternalSystem'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_externalsystem.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Design'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_design.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Class'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_class.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Module'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_module.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Package'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_package.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Component'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_component.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Prototype'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_prototype.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Inspection'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_inspection.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Simulation'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_simulation.jspf" %>
            </c:when>
            <c:when test="${chosenArtifact.childType == 'Test'}">
                <%@ include file="/WEB-INF/jspf/artifacts/viewartifact_test.jspf" %>
            </c:when>
        </c:choose> 
        
       
        
        
    
    
    <%@ include file="/WEB-INF/jspf/trace_footer.jspf" %>
    </body>
</html>
